Browse Source

Update erlang.mk and fix dialyzer plt apps

Viktor Söderqvist 7 years ago
parent
commit
7c95978dbe
4 changed files with 537 additions and 1732 deletions
  1. 1 0
      .gitignore
  2. 9 2
      Makefile
  3. 49 0
      erlang-mk.build.config
  4. 478 1730
      erlang.mk

+ 1 - 0
.gitignore

@@ -1,3 +1,4 @@
+.erlang.mk
 .eunit
 .eunit
 deps
 deps
 *.o
 *.o

+ 9 - 2
Makefile

@@ -8,17 +8,24 @@
 #  - tests-report:   Creates doc/eunit.html with the coverage and eunit output.
 #  - tests-report:   Creates doc/eunit.html with the coverage and eunit output.
 #  - gh-pages:       Generates docs and eunit reports and commits these in the
 #  - gh-pages:       Generates docs and eunit reports and commits these in the
 #                    gh-pages which Github publishes automatically when pushed.
 #                    gh-pages which Github publishes automatically when pushed.
+#  - CHANGELOG.md:   Generates a changelog from the git commits and tags.
 .PHONY: gh-pages tests-report tests-prep CHANGELOG.md
 .PHONY: gh-pages tests-report tests-prep CHANGELOG.md
 
 
 PROJECT = mysql
 PROJECT = mysql
 EDOC_OPTS = {stylesheet_file,"priv/edoc-style.css"},{todo,true}
 EDOC_OPTS = {stylesheet_file,"priv/edoc-style.css"},{todo,true}
-PLT_APPS = crypto
+PLT_APPS = crypto ssl inets public_key
 SHELL_PATH = -pa ebin
 SHELL_PATH = -pa ebin
 
 
+ERLANG_MK_BUILD_CONFIG = erlang-mk.build.config
+
 include erlang.mk
 include erlang.mk
 
 
+# Generate keys for SSL tests. Requires configuring and restarting MySQL.
 tests-prep:
 tests-prep:
-	cd test/ssl && $(MAKE)
+	$(MAKE) -C test/ssl
+
+distclean::
+	$(MAKE) -C test/ssl clean
 
 
 CHANGELOG.md:
 CHANGELOG.md:
 	./changelog.sh > $@
 	./changelog.sh > $@

+ 49 - 0
erlang-mk.build.config

@@ -0,0 +1,49 @@
+# Do *not* comment or remove core modules
+# unless you know what you are doing.
+#
+# Feel free to comment plugins out however.
+
+# Core modules.
+core/core
+#index/*
+#core/index
+#core/deps
+#core/kerl
+
+# Plugins that must run before Erlang code gets compiled.
+plugins/protobuffs
+
+# Core modules, continued.
+core/erlc
+core/docs
+#core/rel
+core/test
+#core/compat
+
+# Plugins.
+#plugins/asciidoc
+#plugins/bootstrap
+#plugins/c_src
+#plugins/ci
+#plugins/ct
+plugins/dialyzer
+plugins/edoc
+#plugins/erlydtl
+#plugins/escript
+plugins/eunit
+#plugins/proper
+#plugins/relx
+plugins/shell
+#plugins/syntastic
+#plugins/triq
+#plugins/xref
+
+# Plugins enhancing the functionality of other plugins.
+plugins/cover
+#plugins/sfx
+
+# External plugins.
+#core/plugins
+
+# Core modules which can use variables from plugins.
+#core/deps-tools

+ 478 - 1730
erlang.mk

@@ -1,4 +1,4 @@
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
+# Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
 #
 #
 # Permission to use, copy, modify, and/or distribute this software for any
 # Permission to use, copy, modify, and/or distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
 # purpose with or without fee is hereby granted, provided that the above
@@ -12,20 +12,43 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
 
-.PHONY: all deps app rel docs install-docs tests check clean distclean help erlang-mk
+.PHONY: all app apps deps search rel relup docs install-docs check tests clean distclean help erlang-mk
 
 
-ERLANG_MK_VERSION = 1.2.0-511-g56f9388
+ERLANG_MK_FILENAME := $(realpath $(lastword $(MAKEFILE_LIST)))
+export ERLANG_MK_FILENAME
+
+ERLANG_MK_VERSION = 2017.08.28-5-g55699ee-dirty
+ERLANG_MK_WITHOUT = 
+
+# Make 3.81 and 3.82 are deprecated.
+
+ifeq ($(MAKE_VERSION),3.81)
+$(warning Please upgrade to GNU Make 4 or later: https://erlang.mk/guide/installation.html)
+endif
+
+ifeq ($(MAKE_VERSION),3.82)
+$(warning Please upgrade to GNU Make 4 or later: https://erlang.mk/guide/installation.html)
+endif
 
 
 # Core configuration.
 # Core configuration.
 
 
 PROJECT ?= $(notdir $(CURDIR))
 PROJECT ?= $(notdir $(CURDIR))
 PROJECT := $(strip $(PROJECT))
 PROJECT := $(strip $(PROJECT))
 
 
+PROJECT_VERSION ?= rolling
+PROJECT_MOD ?= $(PROJECT)_app
+PROJECT_ENV ?= []
+
 # Verbosity.
 # Verbosity.
 
 
 V ?= 0
 V ?= 0
 
 
+verbose_0 = @
+verbose_2 = set -x;
+verbose = $(verbose_$(V))
+
 gen_verbose_0 = @echo " GEN   " $@;
 gen_verbose_0 = @echo " GEN   " $@;
+gen_verbose_2 = set -x;
 gen_verbose = $(gen_verbose_$(V))
 gen_verbose = $(gen_verbose_$(V))
 
 
 # Temporary files directory.
 # Temporary files directory.
@@ -38,7 +61,6 @@ export ERLANG_MK_TMP
 ERL = erl +A0 -noinput -boot start_clean
 ERL = erl +A0 -noinput -boot start_clean
 
 
 # Platform detection.
 # Platform detection.
-# @todo Add Windows/Cygwin detection eventually.
 
 
 ifeq ($(PLATFORM),)
 ifeq ($(PLATFORM),)
 UNAME_S := $(shell uname -s)
 UNAME_S := $(shell uname -s)
@@ -57,6 +79,10 @@ else ifeq ($(UNAME_S),NetBSD)
 PLATFORM = netbsd
 PLATFORM = netbsd
 else ifeq ($(UNAME_S),OpenBSD)
 else ifeq ($(UNAME_S),OpenBSD)
 PLATFORM = openbsd
 PLATFORM = openbsd
+else ifeq ($(UNAME_S),DragonFly)
+PLATFORM = dragonfly
+else ifeq ($(shell uname -o),Msys)
+PLATFORM = msys2
 else
 else
 $(error Unable to detect platform. Please open a ticket with the output of uname -a.)
 $(error Unable to detect platform. Please open a ticket with the output of uname -a.)
 endif
 endif
@@ -66,19 +92,15 @@ endif
 
 
 # Core targets.
 # Core targets.
 
 
-ifneq ($(words $(MAKECMDGOALS)),1)
+all:: deps app rel
-.NOTPARALLEL:
-endif
-
-all:: deps
-	@$(MAKE) --no-print-directory app
-	@$(MAKE) --no-print-directory rel
 
 
 # Noop to avoid a Make warning when there's nothing to do.
 # Noop to avoid a Make warning when there's nothing to do.
 rel::
 rel::
-	@echo -n
+	$(verbose) :
 
 
-check:: clean app tests
+relup:: deps app
+
+check:: tests
 
 
 clean:: clean-crashdump
 clean:: clean-crashdump
 
 
@@ -87,630 +109,97 @@ ifneq ($(wildcard erl_crash.dump),)
 	$(gen_verbose) rm -f erl_crash.dump
 	$(gen_verbose) rm -f erl_crash.dump
 endif
 endif
 
 
-distclean:: clean
+distclean:: clean distclean-tmp
+
+distclean-tmp:
+	$(gen_verbose) rm -rf $(ERLANG_MK_TMP)
 
 
 help::
 help::
-	@printf "%s\n" \
+	$(verbose) printf "%s\n" \
 		"erlang.mk (version $(ERLANG_MK_VERSION)) is distributed under the terms of the ISC License." \
 		"erlang.mk (version $(ERLANG_MK_VERSION)) is distributed under the terms of the ISC License." \
-		"Copyright (c) 2013-2014 Loïc Hoguin <essen@ninenines.eu>" \
+		"Copyright (c) 2013-2016 Loïc Hoguin <essen@ninenines.eu>" \
 		"" \
 		"" \
-		"Usage: [V=1] $(MAKE) [-jNUM] [target]" \
+		"Usage: [V=1] $(MAKE) [target]..." \
 		"" \
 		"" \
 		"Core targets:" \
 		"Core targets:" \
 		"  all           Run deps, app and rel targets in that order" \
 		"  all           Run deps, app and rel targets in that order" \
-		"  deps          Fetch dependencies (if needed) and compile them" \
 		"  app           Compile the project" \
 		"  app           Compile the project" \
+		"  deps          Fetch dependencies (if needed) and compile them" \
+		"  fetch-deps    Fetch dependencies recursively (if needed) without compiling them" \
+		"  list-deps     List dependencies recursively on stdout" \
+		"  search q=...  Search for a package in the built-in index" \
 		"  rel           Build a release for this project, if applicable" \
 		"  rel           Build a release for this project, if applicable" \
 		"  docs          Build the documentation for this project" \
 		"  docs          Build the documentation for this project" \
 		"  install-docs  Install the man pages for this project" \
 		"  install-docs  Install the man pages for this project" \
-		"  tests         Run the tests for this project" \
 		"  check         Compile and run all tests and analysis for this project" \
 		"  check         Compile and run all tests and analysis for this project" \
+		"  tests         Run the tests for this project" \
 		"  clean         Delete temporary and output files from most targets" \
 		"  clean         Delete temporary and output files from most targets" \
 		"  distclean     Delete all temporary and output files" \
 		"  distclean     Delete all temporary and output files" \
 		"  help          Display this help and exit" \
 		"  help          Display this help and exit" \
-		"" \
+		"  erlang-mk     Update erlang.mk to the latest version"
-		"The target clean only removes files that are commonly removed." \
-		"Dependencies and releases are left untouched." \
-		"" \
-		"Setting V=1 when calling $(MAKE) enables verbose mode." \
-		"Parallel execution is supported through the -j $(MAKE) flag."
 
 
 # Core functions.
 # Core functions.
 
 
-define newline
+empty :=
-
+space := $(empty) $(empty)
-
+tab := $(empty)	$(empty)
-endef
+comma := ,
-
-# Adding erlang.mk to make Erlang scripts who call init:get_plain_arguments() happy.
-define erlang
-$(ERL) -pa $(ERLANG_MK_TMP)/ebin -eval "$(subst $(newline),,$(subst ",\",$(1)))" -- erlang.mk
-endef
-
-ifeq ($(shell which wget 2>/dev/null | wc -l), 1)
-define core_http_get
-	wget --no-check-certificate -O $(1) $(2)|| rm $(1)
-endef
-else
-define core_http_get.erl
-	ssl:start(),
-	inets:start(),
-	case httpc:request(get, {"$(2)", []}, [{autoredirect, true}], []) of
-		{ok, {{_, 200, _}, _, Body}} ->
-			case file:write_file("$(1)", Body) of
-				ok -> ok;
-				{error, R1} -> halt(R1)
-			end;
-		{error, R2} ->
-			halt(R2)
-	end,
-	halt(0).
-endef
-
-define core_http_get
-	$(call erlang,$(call core_http_get.erl,$(1),$(2)))
-endef
-endif
-
-# Automated update.
-
-ERLANG_MK_BUILD_CONFIG ?= build.config
-ERLANG_MK_BUILD_DIR ?= .erlang.mk.build
-
-erlang-mk:
-	git clone https://github.com/ninenines/erlang.mk $(ERLANG_MK_BUILD_DIR)
-	if [ -f $(ERLANG_MK_BUILD_CONFIG) ]; then cp $(ERLANG_MK_BUILD_CONFIG) $(ERLANG_MK_BUILD_DIR); fi
-	cd $(ERLANG_MK_BUILD_DIR) && $(MAKE)
-	cp $(ERLANG_MK_BUILD_DIR)/erlang.mk ./erlang.mk
-	rm -rf $(ERLANG_MK_BUILD_DIR)
-
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: distclean-deps distclean-pkg pkg-list pkg-search
-
-# Configuration.
-
-IGNORE_DEPS ?=
-
-DEPS_DIR ?= $(CURDIR)/deps
-export DEPS_DIR
-
-REBAR_DEPS_DIR = $(DEPS_DIR)
-export REBAR_DEPS_DIR
-
-ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(filter-out $(IGNORE_DEPS),$(DEPS)))
-
-ifeq ($(filter $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
-ifeq ($(ERL_LIBS),)
-	ERL_LIBS = $(DEPS_DIR)
-else
-	ERL_LIBS := $(ERL_LIBS):$(DEPS_DIR)
-endif
-endif
-export ERL_LIBS
-
-PKG_FILE2 ?= $(CURDIR)/.erlang.mk.packages.v2
-export PKG_FILE2
-
-PKG_FILE_URL ?= https://raw.githubusercontent.com/ninenines/erlang.mk/master/packages.v2.tsv
-
-# Verbosity.
-
-dep_verbose_0 = @echo " DEP   " $(1);
-dep_verbose = $(dep_verbose_$(V))
 
 
-# Core targets.
+define newline
 
 
-ifneq ($(SKIP_DEPS),)
-deps::
-else
-deps:: $(ALL_DEPS_DIRS)
-	@for dep in $(ALL_DEPS_DIRS) ; do \
-		if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ] ; then \
-			$(MAKE) -C $$dep IS_DEP=1 || exit $$? ; \
-		else \
-			echo "ERROR: No Makefile to build dependency $$dep." ; \
-			exit 1 ; \
-		fi ; \
-	done
-endif
 
 
-distclean:: distclean-deps distclean-pkg
-
-# Deps related targets.
-
-# @todo rename GNUmakefile and makefile into Makefile first, if they exist
-# While Makefile file could be GNUmakefile or makefile,
-# in practice only Makefile is needed so far.
-define dep_autopatch
-	if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
-		if [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
-			$(call dep_autopatch2,$(1)); \
-		elif [ 0 != `grep -ci rebar $(DEPS_DIR)/$(1)/Makefile` ]; then \
-			$(call dep_autopatch2,$(1)); \
-		elif [ 0 != `find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk | xargs grep -ci rebar` ]; then \
-			$(call dep_autopatch2,$(1)); \
-		else \
-			$(call dep_autopatch_erlang_mk,$(1)); \
-		fi \
-	else \
-		if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
-			$(call dep_autopatch_noop,$(1)); \
-		else \
-			$(call dep_autopatch2,$(1)); \
-		fi \
-	fi
 endef
 endef
 
 
-define dep_autopatch2
+define comma_list
-	if [ -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script ]; then \
+$(subst $(space),$(comma),$(strip $(1)))
-		$(call dep_autopatch_rebar_utils); \
-		$(call dep_autopatch_rebar,$(1)); \
-	else \
-		$(call dep_autopatch_gen,$(1)); \
-	fi
 endef
 endef
 
 
-define dep_autopatch_noop
+# Adding erlang.mk to make Erlang scripts who call init:get_plain_arguments() happy.
-	printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
+define erlang
+$(ERL) $(2) -pz $(ERLANG_MK_TMP)/rebar/ebin -eval "$(subst $(newline),,$(subst ",\",$(1)))" -- erlang.mk
 endef
 endef
 
 
-# Overwrite erlang.mk with the current file by default.
+ifeq ($(PLATFORM),msys2)
-ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
+core_native_path = $(subst \,\\\\,$(shell cygpath -w $1))
-define dep_autopatch_erlang_mk
-	rm -f $(DEPS_DIR)/$(1)/erlang.mk; \
-	cd $(DEPS_DIR)/$(1)/ && ln -s ../../erlang.mk; \
-	$(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
-endef
 else
 else
-define dep_autopatch_erlang_mk
+core_native_path = $1
-	$(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
-endef
 endif
 endif
 
 
-define dep_autopatch_gen
+core_http_get = curl -Lf$(if $(filter-out 0,$(V)),,s)o $(call core_native_path,$1) $2
-	printf "%s\n" \
-		"ERLC_OPTS = +debug_info" \
-		"include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile; \
-	$(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
-endef
-
-define dep_autopatch_rebar_utils
-	mkdir -p $(ERLANG_MK_TMP)/ebin; \
-	if [ ! -f $(ERLANG_MK_TMP)/rebar.hrl ]; then \
-		$(call core_http_get,$(ERLANG_MK_TMP)/rebar.hrl,https://raw.githubusercontent.com/rebar/rebar/791db716b5a3a7671e0b351f95ddf24b848ee173/include/rebar.hrl); \
-	fi; \
-	if [ ! -f $(ERLANG_MK_TMP)/rebar_utils.erl ]; then \
-		$(call core_http_get,$(ERLANG_MK_TMP)/rebar_utils.erl,https://raw.githubusercontent.com/rebar/rebar/791db716b5a3a7671e0b351f95ddf24b848ee173/src/rebar_utils.erl); \
-	fi; \
-	if [ ! -f $(ERLANG_MK_TMP)/ebin/rebar_utils.beam ]; then \
-		erlc -o $(ERLANG_MK_TMP)/ebin $(ERLANG_MK_TMP)/rebar_utils.erl; \
-	fi; \
-	if [ ! -f $(ERLANG_MK_TMP)/rebar_log.erl ]; then \
-		$(call core_http_get,$(ERLANG_MK_TMP)/rebar_log.erl,https://raw.githubusercontent.com/rebar/rebar/791db716b5a3a7671e0b351f95ddf24b848ee173/src/rebar_log.erl); \
-	fi; \
-	if [ ! -f $(ERLANG_MK_TMP)/ebin/rebar_log.beam ]; then \
-		erlc -o $(ERLANG_MK_TMP)/ebin $(ERLANG_MK_TMP)/rebar_log.erl; \
-	fi
-endef
-
-define dep_autopatch_rebar
-	if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
-		mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
-	fi; \
-	$(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
-	$(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
-endef
-
-define dep_autopatch_rebar.erl
-	application:set_env(rebar, log_level, debug),
-	Conf1 = case file:consult("$(DEPS_DIR)/$(1)/rebar.config") of
-		{ok, Conf0} -> Conf0;
-		_ -> []
-	end,
-	{Conf, OsEnv} = fun() ->
-		case filelib:is_file("$(DEPS_DIR)/$(1)/rebar.config.script") of
-			false -> {Conf1, []};
-			true ->
-				Bindings0 = erl_eval:new_bindings(),
-				Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
-				Bindings = erl_eval:add_binding('SCRIPT', "$(DEPS_DIR)/$(1)/rebar.config.script", Bindings1),
-				Before = os:getenv(),
-				{ok, Conf2} = file:script("$(DEPS_DIR)/$(1)/rebar.config.script", Bindings),
-				{Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
-		end
-	end(),
-	Write = fun (Text) ->
-		file:write_file("$(DEPS_DIR)/$(1)/Makefile", Text, [append])
-	end,
-	Escape = fun (Text) ->
-		re:replace(Text, "\\\\$$$$", "\$$$$$$$$", [global, {return, list}])
-	end,
-	Write("IGNORE_DEPS = edown eper eunit_formatters meck node_package "
-		"rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
-	Write("C_SRC_DIR = /path/do/not/exist\n"),
-	Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
-	Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
-	fun() ->
-		Write("ERLC_OPTS = +debug_info\n"),
-		case lists:keyfind(erl_opts, 1, Conf) of
-			false -> ok;
-			{_, ErlOpts} ->
-				lists:foreach(fun
-					({d, D}) ->
-						Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
-					({platform_define, Regex, D}) ->
-						case rebar_utils:is_arch(Regex) of
-							true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
-							false -> ok
-						end;
-					({parse_transform, PT}) ->
-						Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
-					(_) -> ok
-				end, ErlOpts)
-		end,
-		Write("\n")
-	end(),
-	fun() ->
-		File = case lists:keyfind(deps, 1, Conf) of
-			false -> [];
-			{_, Deps} ->
-				[begin case case Dep of
-							{N, S} when is_tuple(S) -> {N, S};
-							{N, _, S} -> {N, S};
-							{N, _, S, _} -> {N, S};
-							_ -> false
-						end of
-					false -> ok;
-					{Name, Source} ->
-						{Method, Repo, Commit} = case Source of
-							{git, R} -> {git, R, master};
-							{M, R, {branch, C}} -> {M, R, C};
-							{M, R, {tag, C}} -> {M, R, C};
-							{M, R, C} -> {M, R, C}
-						end,
-						Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
-				end end || Dep <- Deps]
-		end
-	end(),
-	fun() ->
-		First = case lists:keyfind(erl_first_files, 1, Conf) of false -> []; {_, Files} ->
-			Names = [[" ", begin "lre." ++ Elif = lists:reverse(F), lists:reverse(Elif) end]
-				 || "src/" ++ F <- Files],
-			Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
-		end
-	end(),
-	FindFirst = fun(F, Fd) ->
-		case io:parse_erl_form(Fd, undefined) of
-			{ok, {attribute, _,compile, {parse_transform, PT}}, _} ->
-				[PT, F(F, Fd)];
-			{ok, {attribute, _, include, Hrl}, _} ->
-				case file:open("$(DEPS_DIR)/$(1)/include/" ++ Hrl, [read]) of
-					{ok, HrlFd} -> [F(F, HrlFd), F(F, Fd)];
-					_ ->
-						case file:open("$(DEPS_DIR)/$(1)/src/" ++ Hrl, [read]) of
-							{ok, HrlFd} -> [F(F, HrlFd), F(F, Fd)];
-							_ -> [F(F, Fd)]
-						end
-				end;
-			{ok, {attribute, _, include_lib, "$(1)/include/" ++ Hrl}, _} ->
-				{ok, HrlFd} = file:open("$(DEPS_DIR)/$(1)/include/" ++ Hrl, [read]),
-				[F(F, HrlFd), F(F, Fd)];
-			{ok, {attribute, _, import, {Imp, _}}, _} ->
-				case file:open("$(DEPS_DIR)/$(1)/src/" ++ atom_to_list(Imp) ++ ".erl", [read]) of
-					{ok, ImpFd} -> [Imp, F(F, ImpFd), F(F, Fd)];
-					_ -> [F(F, Fd)]
-				end;
-			{eof, _} ->
-				file:close(Fd),
-				[];
-			_ ->
-				F(F, Fd)
-		end
-	end,
-	fun() ->
-		ErlFiles = filelib:wildcard("$(DEPS_DIR)/$(1)/src/*.erl"),
-		First0 = lists:usort(lists:flatten([begin
-			{ok, Fd} = file:open(F, [read]),
-			FindFirst(FindFirst, Fd)
-		end || F <- ErlFiles])),
-		First = lists:flatten([begin
-			{ok, Fd} = file:open("$(DEPS_DIR)/$(1)/src/" ++ atom_to_list(M) ++ ".erl", [read]),
-			FindFirst(FindFirst, Fd)
-		end || M <- First0, lists:member("$(DEPS_DIR)/$(1)/src/" ++ atom_to_list(M) ++ ".erl", ErlFiles)]) ++ First0,
-		Write(["COMPILE_FIRST +=", [[" ", atom_to_list(M)] || M <- First,
-			lists:member("$(DEPS_DIR)/$(1)/src/" ++ atom_to_list(M) ++ ".erl", ErlFiles)], "\n"])
-	end(),
-	Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
-	Write("\npreprocess::\n"),
-	Write("\npre-deps::\n"),
-	Write("\npre-app::\n"),
-	PatchHook = fun(Cmd) ->
-		case Cmd of
-			"make -C" ++ _ -> Escape(Cmd);
-			"gmake -C" ++ _ -> Escape(Cmd);
-			"make " ++ Cmd1 -> "make -f Makefile.orig.mk " ++ Escape(Cmd1);
-			"gmake " ++ Cmd1 -> "gmake -f Makefile.orig.mk " ++ Escape(Cmd1);
-			_ -> Escape(Cmd)
-		end
-	end,
-	fun() ->
-		case lists:keyfind(pre_hooks, 1, Conf) of
-			false -> ok;
-			{_, Hooks} ->
-				[case H of
-					{'get-deps', Cmd} ->
-						Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
-					{compile, Cmd} ->
-						Write("\npre-app::\n\t" ++ PatchHook(Cmd) ++ "\n");
-					{Regex, compile, Cmd} ->
-						case rebar_utils:is_arch(Regex) of
-							true -> Write("\npre-app::\n\t" ++ PatchHook(Cmd) ++ "\n");
-							false -> ok
-						end;
-					_ -> ok
-				end || H <- Hooks]
-		end
-	end(),
-	ShellToMk = fun(V) ->
-		re:replace(V, "(\\\\$$$$)(\\\\w*)", "\\\\1(\\\\2)", [{return, list}, global])
-	end,
-	PortSpecs = fun() ->
-		case lists:keyfind(port_specs, 1, Conf) of
-			false ->
-				case filelib:is_dir("$(DEPS_DIR)/$(1)/c_src") of
-					false -> [];
-					true ->
-						[{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
-							proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
-				end;
-			{_, Specs} ->
-				lists:flatten([case S of
-					{Output, Input} -> {ShellToMk(Output), Input, []};
-					{Regex, Output, Input} ->
-						case rebar_utils:is_arch(Regex) of
-							true -> {ShellToMk(Output), Input, []};
-							false -> []
-						end;
-					{Regex, Output, Input, [{env, Env}]} ->
-						case rebar_utils:is_arch(Regex) of
-							true -> {ShellToMk(Output), Input, Env};
-							false -> []
-						end
-				end || S <- Specs])
-		end
-	end(),
-	PortSpecWrite = fun (Text) ->
-		file:write_file("$(DEPS_DIR)/$(1)/c_src/Makefile.erlang.mk", Text, [append])
-	end,
-	case PortSpecs of
-		[] -> ok;
-		_ ->
-			Write("\npre-app::\n\t$$$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
-			PortSpecWrite(io_lib:format("ERL_CFLAGS = -finline-functions -Wall -fPIC -I ~s/erts-~s/include -I ~s\n",
-				[code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
-			PortSpecWrite(io_lib:format("ERL_LDFLAGS = -L ~s -lerl_interface -lei\n",
-				[code:lib_dir(erl_interface, lib)])),
-			[PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
-			FilterEnv = fun(Env) ->
-				lists:flatten([case E of
-					{_, _} -> E;
-					{Regex, K, V} ->
-						case rebar_utils:is_arch(Regex) of
-							true -> {K, V};
-							false -> []
-						end
-				end || E <- Env])
-			end,
-			MergeEnv = fun(Env) ->
-				lists:foldl(fun ({K, V}, Acc) ->
-					case lists:keyfind(K, 1, Acc) of
-						false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
-						{_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
-					end
-				end, [], Env)
-			end,
-			PortEnv = case lists:keyfind(port_env, 1, Conf) of
-				false -> [];
-				{_, PortEnv0} -> FilterEnv(PortEnv0)
-			end,
-			PortSpec = fun ({Output, Input0, Env}) ->
-				filelib:ensure_dir("$(DEPS_DIR)/$(1)/" ++ Output),
-				Input = [[" ", I] || I <- Input0],
-				PortSpecWrite([
-					[["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
-					"\n\nall:: ", Output, "\n\n",
-					"%.o: %.c\n\t$$$$\(CC) -c -o $$$$\@ $$$$\< $$$$\(CFLAGS) $$$$\(ERL_CFLAGS) $$$$\(DRV_CFLAGS) $$$$\(EXE_CFLAGS)\n\n",
-					"%.o: %.C\n\t$$$$\(CXX) -c -o $$$$\@ $$$$\< $$$$\(CXXFLAGS) $$$$\(ERL_CFLAGS) $$$$\(DRV_CFLAGS) $$$$\(EXE_CFLAGS)\n\n",
-					"%.o: %.cc\n\t$$$$\(CXX) -c -o $$$$\@ $$$$\< $$$$\(CXXFLAGS) $$$$\(ERL_CFLAGS) $$$$\(DRV_CFLAGS) $$$$\(EXE_CFLAGS)\n\n",
-					"%.o: %.cpp\n\t$$$$\(CXX) -c -o $$$$\@ $$$$\< $$$$\(CXXFLAGS) $$$$\(ERL_CFLAGS) $$$$\(DRV_CFLAGS) $$$$\(EXE_CFLAGS)\n\n",
-					[[Output, ": ", K, " = ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
-					Output, ": $$$$\(foreach ext,.c .C .cc .cpp,",
-						"$$$$\(patsubst %$$$$\(ext),%.o,$$$$\(filter %$$$$\(ext),$$$$\(wildcard", Input, "))))\n",
-					"\t$$$$\(CC) -o $$$$\@ $$$$\? $$$$\(LDFLAGS) $$$$\(ERL_LDFLAGS) $$$$\(DRV_LDFLAGS) $$$$\(EXE_LDFLAGS)",
-					case filename:extension(Output) of
-						[] -> "\n";
-						_ -> " -shared\n"
-					end])
-			end,
-			[PortSpec(S) || S <- PortSpecs]
-	end,
-	Write("\ninclude ../../erlang.mk"),
-	PatchPlugin = fun(ErlFile) ->
-		{ok, F0} = file:read_file(ErlFile),
-		case re:replace(F0, "rebar_config:", "rebar_config_", [global]) of
-			F0 -> ok;
-			F ->
-				ok = file:write_file(ErlFile, [F,
-					"\nrebar_config_get(_, current_command, _) -> compile.\n"
-				])
-		end
-	end,
-	RunPlugin = fun(Plugin, Step) ->
-		case erlang:function_exported(Plugin, Step, 2) of
-			false -> ok;
-			true ->
-				c:cd("$(DEPS_DIR)/$(1)/"),
-				Ret = Plugin:Step(Conf, undefined),
-				io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
-		end
-	end,
-	fun() ->
-		case lists:keyfind(plugins, 1, Conf) of
-			false -> ok;
-			{_, Plugins} ->
-				[begin
-					case lists:keyfind(deps, 1, Conf) of
-						false -> ok;
-						{_, Deps} ->
-							case lists:keyfind(P, 1, Deps) of
-								false -> ok;
-								_ ->
-									Path = "$(DEPS_DIR)/" ++ atom_to_list(P),
-									io:format("~s", [os:cmd("$(MAKE) -C $(DEPS_DIR)/$(1) " ++ Path)]),
-									io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
-									code:add_patha(Path ++ "/ebin")
-							end
-					end
-				end || P <- Plugins],
-				[case code:load_file(P) of
-					{module, P} -> ok;
-					_ ->
-						case lists:keyfind(plugin_dir, 1, Conf) of
-							false -> ok;
-							{_, PluginsDir} ->
-								ErlFile = "$(DEPS_DIR)/$(1)/" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
-								PatchPlugin(ErlFile),
-								{ok, P, Bin} = compile:file(ErlFile, [binary]),
-								{module, P} = code:load_binary(P, ErlFile, Bin)
-						end
-				end || P <- Plugins],
-				[RunPlugin(P, preprocess) || P <- Plugins],
-				[RunPlugin(P, pre_compile) || P <- Plugins]
-		end
-	end(),
-	halt()
-endef
-
-define dep_autopatch_appsrc.erl
-	AppSrcOut = "$(DEPS_DIR)/$(1)/src/$(1).app.src",
-	AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(DEPS_DIR)/$(1)/ebin/$(1).app"; true -> AppSrcOut end,
-	case filelib:is_regular(AppSrcIn) of
-		false -> ok;
-		true ->
-			fun() ->
-				{ok, [{application, $(1), L}]} = file:consult(AppSrcIn),
-				L2 = lists:keystore(modules, 1, L, {modules, []}),
-				L3 = case lists:keyfind(vsn, 1, L2) of {vsn, git} -> lists:keyreplace(vsn, 1, L2, {vsn, "git"}); _ -> L2 end,
-				ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}]))
-			end(),
-			case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
-	end,
-	halt()
-endef
-
-define dep_fetch
-	if [ "$$$$VS" = "git" ]; then \
-		git clone -q -n -- $$$$REPO $(DEPS_DIR)/$(1); \
-		cd $(DEPS_DIR)/$(1) && git checkout -q $$$$COMMIT; \
-	elif [ "$$$$VS" = "hg" ]; then \
-		hg clone -q -U $$$$REPO $(DEPS_DIR)/$(1); \
-		cd $(DEPS_DIR)/$(1) && hg update -q $$$$COMMIT; \
-	elif [ "$$$$VS" = "svn" ]; then \
-		svn checkout -q $$$$REPO $(DEPS_DIR)/$(1); \
-	elif [ "$$$$VS" = "cp" ]; then \
-		cp -R $$$$REPO $(DEPS_DIR)/$(1); \
-	else \
-		echo "Unknown or invalid dependency: $(1). Please consult the erlang.mk README for instructions." >&2; \
-		exit 78; \
-	fi
-endef
 
 
-define dep_target
+core_eq = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
-$(DEPS_DIR)/$(1):
-	@mkdir -p $(DEPS_DIR)
-ifeq (,$(dep_$(1)))
-	@if [ ! -f $(PKG_FILE2) ]; then $(call core_http_get,$(PKG_FILE2),$(PKG_FILE_URL)); fi
-	$(dep_verbose) DEPPKG=$$$$(awk 'BEGIN { FS = "\t" }; $$$$1 == "$(1)" { print $$$$2 " " $$$$3 " " $$$$4 }' $(PKG_FILE2);); \
-	VS=$$$$(echo $$$$DEPPKG | cut -d " " -f1); \
-	REPO=$$$$(echo $$$$DEPPKG | cut -d " " -f2); \
-	COMMIT=$$$$(echo $$$$DEPPKG | cut -d " " -f3); \
-	$(call dep_fetch,$(1))
-else
-ifeq (1,$(words $(dep_$(1))))
-	$(dep_verbose) VS=git; \
-	REPO=$(dep_$(1)); \
-	COMMIT=master; \
-	$(call dep_fetch,$(1))
-else
-ifeq (2,$(words $(dep_$(1))))
-	$(dep_verbose) VS=git; \
-	REPO=$(word 1,$(dep_$(1))); \
-	COMMIT=$(word 2,$(dep_$(1))); \
-	$(call dep_fetch,$(1))
-else
-	$(dep_verbose) VS=$(word 1,$(dep_$(1))); \
-	REPO=$(word 2,$(dep_$(1))); \
-	COMMIT=$(word 3,$(dep_$(1))); \
-	$(call dep_fetch,$(1))
-endif
-endif
-endif
-	@if [ -f $(DEPS_DIR)/$(1)/configure.ac ]; then \
-		echo " AUTO  " $(1); \
-		cd $(DEPS_DIR)/$(1) && autoreconf -vif; \
-	fi
-	-@if [ -f $(DEPS_DIR)/$(1)/configure ]; then \
-		echo " CONF  " $(1); \
-		cd $(DEPS_DIR)/$(1) && ./configure; \
-	fi
-ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
-	@$(call dep_autopatch,$(1))
-endif
-endef
 
 
-$(foreach dep,$(DEPS),$(eval $(call dep_target,$(dep))))
+core_find = $(if $(wildcard $1),$(shell find $(1:%/=%) -type f -name $(subst *,\*,$2)))
 
 
-distclean-deps:
+core_lc = $(subst A,a,$(subst B,b,$(subst C,c,$(subst D,d,$(subst E,e,$(subst F,f,$(subst G,g,$(subst H,h,$(subst I,i,$(subst J,j,$(subst K,k,$(subst L,l,$(subst M,m,$(subst N,n,$(subst O,o,$(subst P,p,$(subst Q,q,$(subst R,r,$(subst S,s,$(subst T,t,$(subst U,u,$(subst V,v,$(subst W,w,$(subst X,x,$(subst Y,y,$(subst Z,z,$(1)))))))))))))))))))))))))))
-	$(gen_verbose) rm -rf $(DEPS_DIR)
 
 
-# Packages related targets.
+core_ls = $(filter-out $(1),$(shell echo $(1)))
 
 
-$(PKG_FILE2):
+# @todo Use a solution that does not require using perl.
-	@$(call core_http_get,$(PKG_FILE2),$(PKG_FILE_URL))
+core_relpath = $(shell perl -e 'use File::Spec; print File::Spec->abs2rel(@ARGV) . "\n"' $1 $2)
 
 
-pkg-list: $(PKG_FILE2)
+# Automated update.
-	@cat $(PKG_FILE2) | awk 'BEGIN { FS = "\t" }; { print \
-		"Name:\t\t" $$1 "\n" \
-		"Repository:\t" $$3 "\n" \
-		"Website:\t" $$5 "\n" \
-		"Description:\t" $$6 "\n" }'
 
 
-ifdef q
+ERLANG_MK_REPO ?= https://github.com/ninenines/erlang.mk
-pkg-search: $(PKG_FILE2)
+ERLANG_MK_COMMIT ?=
-	@cat $(PKG_FILE2) | grep -i ${q} | awk 'BEGIN { FS = "\t" }; { print \
+ERLANG_MK_BUILD_CONFIG ?= build.config
-		"Name:\t\t" $$1 "\n" \
+ERLANG_MK_BUILD_DIR ?= .erlang.mk.build
-		"Repository:\t" $$3 "\n" \
-		"Website:\t" $$5 "\n" \
-		"Description:\t" $$6 "\n" }'
-else
-pkg-search:
-	$(error Usage: $(MAKE) pkg-search q=STRING)
-endif
 
 
-ifeq ($(PKG_FILE2),$(CURDIR)/.erlang.mk.packages.v2)
+erlang-mk: WITHOUT ?= $(ERLANG_MK_WITHOUT)
-distclean-pkg:
+erlang-mk:
-	$(gen_verbose) rm -f $(PKG_FILE2)
+	git clone $(ERLANG_MK_REPO) $(ERLANG_MK_BUILD_DIR)
+ifdef ERLANG_MK_COMMIT
+	cd $(ERLANG_MK_BUILD_DIR) && git checkout $(ERLANG_MK_COMMIT)
 endif
 endif
+	if [ -f $(ERLANG_MK_BUILD_CONFIG) ]; then cp $(ERLANG_MK_BUILD_CONFIG) $(ERLANG_MK_BUILD_DIR)/build.config; fi
+	$(MAKE) -C $(ERLANG_MK_BUILD_DIR) WITHOUT='$(strip $(WITHOUT))'
+	cp $(ERLANG_MK_BUILD_DIR)/erlang.mk ./erlang.mk
+	rm -rf $(ERLANG_MK_BUILD_DIR)
 
 
-help::
+# The erlang.mk package index is bundled in the default erlang.mk build.
-	@printf "%s\n" "" \
+# Search for the string "copyright" to skip to the rest of the code.
-		"Package-related targets:" \
-		"  pkg-list              List all known packages" \
-		"  pkg-search q=STRING   Search for STRING in the package index"
 
 
-# Copyright (c) 2015, Loïc Hoguin <essen@ninenines.eu>
+# Copyright (c) 2015-2016, Loïc Hoguin <essen@ninenines.eu>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
 # Verbosity.
 # Verbosity.
@@ -721,28 +210,27 @@ proto_verbose = $(proto_verbose_$(V))
 # Core targets.
 # Core targets.
 
 
 define compile_proto
 define compile_proto
-	@mkdir -p ebin/ include/
+	$(verbose) mkdir -p ebin/ include/
 	$(proto_verbose) $(call erlang,$(call compile_proto.erl,$(1)))
 	$(proto_verbose) $(call erlang,$(call compile_proto.erl,$(1)))
 	$(proto_verbose) erlc +debug_info -o ebin/ ebin/*.erl
 	$(proto_verbose) erlc +debug_info -o ebin/ ebin/*.erl
-	@rm ebin/*.erl
+	$(verbose) rm ebin/*.erl
 endef
 endef
 
 
 define compile_proto.erl
 define compile_proto.erl
 	[begin
 	[begin
-		Dir = filename:dirname(filename:dirname(F)),
 		protobuffs_compile:generate_source(F,
 		protobuffs_compile:generate_source(F,
-			[{output_include_dir, Dir ++ "/include"},
+			[{output_include_dir, "./include"},
-				{output_src_dir, Dir ++ "/ebin"}])
+				{output_src_dir, "./ebin"}])
 	end || F <- string:tokens("$(1)", " ")],
 	end || F <- string:tokens("$(1)", " ")],
 	halt().
 	halt().
 endef
 endef
 
 
 ifneq ($(wildcard src/),)
 ifneq ($(wildcard src/),)
-ebin/$(PROJECT).app:: $(shell find src -type f -name \*.proto 2>/dev/null)
+ebin/$(PROJECT).app:: $(sort $(call core_find,src/,*.proto))
 	$(if $(strip $?),$(call compile_proto,$?))
 	$(if $(strip $?),$(call compile_proto,$?))
 endif
 endif
 
 
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
+# Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
 .PHONY: clean-app
 .PHONY: clean-app
@@ -756,110 +244,289 @@ COMPILE_FIRST_PATHS = $(addprefix src/,$(addsuffix .erl,$(COMPILE_FIRST)))
 ERLC_EXCLUDE ?=
 ERLC_EXCLUDE ?=
 ERLC_EXCLUDE_PATHS = $(addprefix src/,$(addsuffix .erl,$(ERLC_EXCLUDE)))
 ERLC_EXCLUDE_PATHS = $(addprefix src/,$(addsuffix .erl,$(ERLC_EXCLUDE)))
 
 
+ERLC_ASN1_OPTS ?=
+
 ERLC_MIB_OPTS ?=
 ERLC_MIB_OPTS ?=
 COMPILE_MIB_FIRST ?=
 COMPILE_MIB_FIRST ?=
 COMPILE_MIB_FIRST_PATHS = $(addprefix mibs/,$(addsuffix .mib,$(COMPILE_MIB_FIRST)))
 COMPILE_MIB_FIRST_PATHS = $(addprefix mibs/,$(addsuffix .mib,$(COMPILE_MIB_FIRST)))
 
 
 # Verbosity.
 # Verbosity.
 
 
+app_verbose_0 = @echo " APP   " $(PROJECT);
+app_verbose_2 = set -x;
+app_verbose = $(app_verbose_$(V))
+
 appsrc_verbose_0 = @echo " APP   " $(PROJECT).app.src;
 appsrc_verbose_0 = @echo " APP   " $(PROJECT).app.src;
+appsrc_verbose_2 = set -x;
 appsrc_verbose = $(appsrc_verbose_$(V))
 appsrc_verbose = $(appsrc_verbose_$(V))
 
 
+makedep_verbose_0 = @echo " DEPEND" $(PROJECT).d;
+makedep_verbose_2 = set -x;
+makedep_verbose = $(makedep_verbose_$(V))
+
 erlc_verbose_0 = @echo " ERLC  " $(filter-out $(patsubst %,%.erl,$(ERLC_EXCLUDE)),\
 erlc_verbose_0 = @echo " ERLC  " $(filter-out $(patsubst %,%.erl,$(ERLC_EXCLUDE)),\
 	$(filter %.erl %.core,$(?F)));
 	$(filter %.erl %.core,$(?F)));
+erlc_verbose_2 = set -x;
 erlc_verbose = $(erlc_verbose_$(V))
 erlc_verbose = $(erlc_verbose_$(V))
 
 
 xyrl_verbose_0 = @echo " XYRL  " $(filter %.xrl %.yrl,$(?F));
 xyrl_verbose_0 = @echo " XYRL  " $(filter %.xrl %.yrl,$(?F));
+xyrl_verbose_2 = set -x;
 xyrl_verbose = $(xyrl_verbose_$(V))
 xyrl_verbose = $(xyrl_verbose_$(V))
 
 
 asn1_verbose_0 = @echo " ASN1  " $(filter %.asn1,$(?F));
 asn1_verbose_0 = @echo " ASN1  " $(filter %.asn1,$(?F));
+asn1_verbose_2 = set -x;
 asn1_verbose = $(asn1_verbose_$(V))
 asn1_verbose = $(asn1_verbose_$(V))
 
 
 mib_verbose_0 = @echo " MIB   " $(filter %.bin %.mib,$(?F));
 mib_verbose_0 = @echo " MIB   " $(filter %.bin %.mib,$(?F));
+mib_verbose_2 = set -x;
 mib_verbose = $(mib_verbose_$(V))
 mib_verbose = $(mib_verbose_$(V))
 
 
+ifneq ($(wildcard src/),)
+
 # Targets.
 # Targets.
 
 
 ifeq ($(wildcard ebin/test),)
 ifeq ($(wildcard ebin/test),)
-app:: app-build
+app:: deps $(PROJECT).d
+	$(verbose) $(MAKE) --no-print-directory app-build
 else
 else
-app:: clean app-build
+app:: clean deps $(PROJECT).d
+	$(verbose) $(MAKE) --no-print-directory app-build
 endif
 endif
 
 
-app-build: erlc-include ebin/$(PROJECT).app
+ifeq ($(wildcard src/$(PROJECT_MOD).erl),)
-	$(eval MODULES := $(shell find ebin -type f -name \*.beam \
+define app_file
-		| sed "s/ebin\//'/;s/\.beam/',/" | sed '$$s/.$$//'))
+{application, '$(PROJECT)', [
-	@if [ -z "$$(grep -E '^[^%]*{modules,' src/$(PROJECT).app.src)" ]; then \
+	{description, "$(PROJECT_DESCRIPTION)"},
-		echo "Empty modules entry not found in $(PROJECT).app.src. Please consult the erlang.mk README for instructions." >&2; \
+	{vsn, "$(PROJECT_VERSION)"},$(if $(IS_DEP),
-		exit 1; \
+	{id$(comma)$(space)"$(1)"}$(comma))
-	fi
+	{modules, [$(call comma_list,$(2))]},
-	$(eval GITDESCRIBE := $(shell git describe --dirty --abbrev=7 --tags --always --first-parent 2>/dev/null || true))
+	{registered, []},
-	$(appsrc_verbose) cat src/$(PROJECT).app.src \
+	{applications, [$(call comma_list,kernel stdlib $(OTP_DEPS) $(LOCAL_DEPS) $(DEPS))]},
-		| sed "s/{modules,[[:space:]]*\[\]}/{modules, \[$(MODULES)\]}/" \
+	{env, $(subst \,\\,$(PROJECT_ENV))}$(if $(findstring {,$(PROJECT_APP_EXTRA_KEYS)),$(comma)$(newline)$(tab)$(subst \,\\,$(PROJECT_APP_EXTRA_KEYS)),)
-		| sed "s/{id,[[:space:]]*\"git\"}/{id, \"$(GITDESCRIBE)\"}/" \
+]}.
-		> ebin/$(PROJECT).app
-
-erlc-include:
-	-@if [ -d ebin/ ]; then \
-		find include/ src/ -type f -name \*.hrl -newer ebin -exec touch $(shell find src/ -type f -name "*.erl") \; 2>/dev/null || printf ''; \
-	fi
-
-define compile_erl
-	$(erlc_verbose) erlc -v $(ERLC_OPTS) -o ebin/ \
-		-pa ebin/ -I include/ $(filter-out $(ERLC_EXCLUDE_PATHS),\
-		$(COMPILE_FIRST_PATHS) $(1))
 endef
 endef
-
+else
-define compile_xyrl
+define app_file
-	$(xyrl_verbose) erlc -v -o ebin/ $(1)
+{application, '$(PROJECT)', [
-	$(xyrl_verbose) erlc $(ERLC_OPTS) -o ebin/ ebin/*.erl
+	{description, "$(PROJECT_DESCRIPTION)"},
-	@rm ebin/*.erl
+	{vsn, "$(PROJECT_VERSION)"},$(if $(IS_DEP),
+	{id$(comma)$(space)"$(1)"}$(comma))
+	{modules, [$(call comma_list,$(2))]},
+	{registered, [$(call comma_list,$(PROJECT)_sup $(PROJECT_REGISTERED))]},
+	{applications, [$(call comma_list,kernel stdlib $(OTP_DEPS) $(LOCAL_DEPS) $(DEPS))]},
+	{mod, {$(PROJECT_MOD), []}},
+	{env, $(subst \,\\,$(PROJECT_ENV))}$(if $(findstring {,$(PROJECT_APP_EXTRA_KEYS)),$(comma)$(newline)$(tab)$(subst \,\\,$(PROJECT_APP_EXTRA_KEYS)),)
+]}.
 endef
 endef
+endif
 
 
-define compile_asn1
+app-build: ebin/$(PROJECT).app
-	$(asn1_verbose) erlc -v -I include/ -o ebin/ $(1)
+	$(verbose) :
-	@mv ebin/*.hrl include/
-	@mv ebin/*.asn1db include/
-	@rm ebin/*.erl
-endef
 
 
-define compile_mib
+# Source files.
-	$(mib_verbose) erlc -v $(ERLC_MIB_OPTS) -o priv/mibs/ \
-		-I priv/mibs/ $(COMPILE_MIB_FIRST_PATHS) $(1)
-	$(mib_verbose) erlc -o include/ -- priv/mibs/*.bin
-endef
 
 
-ifneq ($(wildcard src/),)
+ALL_SRC_FILES := $(sort $(call core_find,src/,*))
-ebin/$(PROJECT).app::
+
-	@mkdir -p ebin/
+ERL_FILES := $(filter %.erl,$(ALL_SRC_FILES))
+CORE_FILES := $(filter %.core,$(ALL_SRC_FILES))
+
+# ASN.1 files.
 
 
 ifneq ($(wildcard asn1/),)
 ifneq ($(wildcard asn1/),)
-ebin/$(PROJECT).app:: $(shell find asn1 -type f -name \*.asn1)
+ASN1_FILES = $(sort $(call core_find,asn1/,*.asn1))
-	@mkdir -p include
+ERL_FILES += $(addprefix src/,$(patsubst %.asn1,%.erl,$(notdir $(ASN1_FILES))))
+
+define compile_asn1
+	$(verbose) mkdir -p include/
+	$(asn1_verbose) erlc -v -I include/ -o asn1/ +noobj $(ERLC_ASN1_OPTS) $(1)
+	$(verbose) mv asn1/*.erl src/
+	$(verbose) mv asn1/*.hrl include/
+	$(verbose) mv asn1/*.asn1db include/
+endef
+
+$(PROJECT).d:: $(ASN1_FILES)
 	$(if $(strip $?),$(call compile_asn1,$?))
 	$(if $(strip $?),$(call compile_asn1,$?))
 endif
 endif
 
 
+# SNMP MIB files.
+
 ifneq ($(wildcard mibs/),)
 ifneq ($(wildcard mibs/),)
-ebin/$(PROJECT).app:: $(shell find mibs -type f -name \*.mib)
+MIB_FILES = $(sort $(call core_find,mibs/,*.mib))
-	@mkdir -p priv/mibs/ include
+
-	$(if $(strip $?),$(call compile_mib,$?))
+$(PROJECT).d:: $(COMPILE_MIB_FIRST_PATHS) $(MIB_FILES)
+	$(verbose) mkdir -p include/ priv/mibs/
+	$(mib_verbose) erlc -v $(ERLC_MIB_OPTS) -o priv/mibs/ -I priv/mibs/ $?
+	$(mib_verbose) erlc -o include/ -- $(addprefix priv/mibs/,$(patsubst %.mib,%.bin,$(notdir $?)))
+endif
+
+# Leex and Yecc files.
+
+XRL_FILES := $(filter %.xrl,$(ALL_SRC_FILES))
+XRL_ERL_FILES = $(addprefix src/,$(patsubst %.xrl,%.erl,$(notdir $(XRL_FILES))))
+ERL_FILES += $(XRL_ERL_FILES)
+
+YRL_FILES := $(filter %.yrl,$(ALL_SRC_FILES))
+YRL_ERL_FILES = $(addprefix src/,$(patsubst %.yrl,%.erl,$(notdir $(YRL_FILES))))
+ERL_FILES += $(YRL_ERL_FILES)
+
+$(PROJECT).d:: $(XRL_FILES) $(YRL_FILES)
+	$(if $(strip $?),$(xyrl_verbose) erlc -v -o src/ $(YRL_ERLC_OPTS) $?)
+
+# Erlang and Core Erlang files.
+
+define makedep.erl
+	E = ets:new(makedep, [bag]),
+	G = digraph:new([acyclic]),
+	ErlFiles = lists:usort(string:tokens("$(ERL_FILES)", " ")),
+	Modules = [{list_to_atom(filename:basename(F, ".erl")), F} || F <- ErlFiles],
+	Add = fun (Mod, Dep) ->
+		case lists:keyfind(Dep, 1, Modules) of
+			false -> ok;
+			{_, DepFile} ->
+				{_, ModFile} = lists:keyfind(Mod, 1, Modules),
+				ets:insert(E, {ModFile, DepFile}),
+				digraph:add_vertex(G, Mod),
+				digraph:add_vertex(G, Dep),
+				digraph:add_edge(G, Mod, Dep)
+		end
+	end,
+	AddHd = fun (F, Mod, DepFile) ->
+		case file:open(DepFile, [read]) of
+			{error, enoent} -> ok;
+			{ok, Fd} ->
+				F(F, Fd, Mod),
+				{_, ModFile} = lists:keyfind(Mod, 1, Modules),
+				ets:insert(E, {ModFile, DepFile})
+		end
+	end,
+	Attr = fun
+		(F, Mod, behavior, Dep) -> Add(Mod, Dep);
+		(F, Mod, behaviour, Dep) -> Add(Mod, Dep);
+		(F, Mod, compile, {parse_transform, Dep}) -> Add(Mod, Dep);
+		(F, Mod, compile, Opts) when is_list(Opts) ->
+			case proplists:get_value(parse_transform, Opts) of
+				undefined -> ok;
+				Dep -> Add(Mod, Dep)
+			end;
+		(F, Mod, include, Hrl) ->
+			case filelib:is_file("include/" ++ Hrl) of
+				true -> AddHd(F, Mod, "include/" ++ Hrl);
+				false ->
+					case filelib:is_file("src/" ++ Hrl) of
+						true -> AddHd(F, Mod, "src/" ++ Hrl);
+						false -> false
+					end
+			end;
+		(F, Mod, include_lib, "$1/include/" ++ Hrl) -> AddHd(F, Mod, "include/" ++ Hrl);
+		(F, Mod, include_lib, Hrl) -> AddHd(F, Mod, "include/" ++ Hrl);
+		(F, Mod, import, {Imp, _}) ->
+			IsFile =
+				case lists:keyfind(Imp, 1, Modules) of
+					false -> false;
+					{_, FilePath} -> filelib:is_file(FilePath)
+				end,
+			case IsFile of
+				false -> ok;
+				true -> Add(Mod, Imp)
+			end;
+		(_, _, _, _) -> ok
+	end,
+	MakeDepend = fun(F, Fd, Mod) ->
+		case io:parse_erl_form(Fd, undefined) of
+			{ok, {attribute, _, Key, Value}, _} ->
+				Attr(F, Mod, Key, Value),
+				F(F, Fd, Mod);
+			{eof, _} ->
+				file:close(Fd);
+			_ ->
+				F(F, Fd, Mod)
+		end
+	end,
+	[begin
+		Mod = list_to_atom(filename:basename(F, ".erl")),
+		{ok, Fd} = file:open(F, [read]),
+		MakeDepend(MakeDepend, Fd, Mod)
+	end || F <- ErlFiles],
+	Depend = sofs:to_external(sofs:relation_to_family(sofs:relation(ets:tab2list(E)))),
+	CompileFirst = [X || X <- lists:reverse(digraph_utils:topsort(G)), [] =/= digraph:in_neighbours(G, X)],
+	TargetPath = fun(Target) ->
+		case lists:keyfind(Target, 1, Modules) of
+			false -> "";
+			{_, DepFile} ->
+				DirSubname = tl(string:tokens(filename:dirname(DepFile), "/")),
+				string:join(DirSubname ++ [atom_to_list(Target)], "/")
+		end
+	end,
+	ok = file:write_file("$(1)", [
+		[[F, "::", [[" ", D] || D <- Deps], "; @touch \$$@\n"] || {F, Deps} <- Depend],
+		"\nCOMPILE_FIRST +=", [[" ", TargetPath(CF)] || CF <- CompileFirst], "\n"
+	]),
+	halt()
+endef
+
+ifeq ($(if $(NO_MAKEDEP),$(wildcard $(PROJECT).d),),)
+$(PROJECT).d:: $(ERL_FILES) $(call core_find,include/,*.hrl) $(MAKEFILE_LIST)
+	$(makedep_verbose) $(call erlang,$(call makedep.erl,$@))
+endif
+
+ifneq ($(words $(ERL_FILES) $(CORE_FILES) $(ASN1_FILES) $(MIB_FILES) $(XRL_FILES) $(YRL_FILES)),0)
+# Rebuild everything when the Makefile changes.
+$(ERLANG_MK_TMP)/last-makefile-change: $(MAKEFILE_LIST)
+	$(verbose) mkdir -p $(ERLANG_MK_TMP)
+	$(verbose) if test -f $@; then \
+		touch $(ERL_FILES) $(CORE_FILES) $(ASN1_FILES) $(MIB_FILES) $(XRL_FILES) $(YRL_FILES); \
+		touch -c $(PROJECT).d; \
+	fi
+	$(verbose) touch $@
+
+$(ERL_FILES) $(CORE_FILES) $(ASN1_FILES) $(MIB_FILES) $(XRL_FILES) $(YRL_FILES):: $(ERLANG_MK_TMP)/last-makefile-change
+ebin/$(PROJECT).app:: $(ERLANG_MK_TMP)/last-makefile-change
 endif
 endif
 
 
-ebin/$(PROJECT).app:: $(shell find src -type f -name \*.erl) \
+include $(wildcard $(PROJECT).d)
-		$(shell find src -type f -name \*.core)
+
-	$(if $(strip $?),$(call compile_erl,$?))
+ebin/$(PROJECT).app:: ebin/
 
 
-ebin/$(PROJECT).app:: $(shell find src -type f -name \*.xrl) \
+ebin/:
-		$(shell find src -type f -name \*.yrl)
+	$(verbose) mkdir -p ebin/
-	$(if $(strip $?),$(call compile_xyrl,$?))
+
+define compile_erl
+	$(erlc_verbose) erlc -v $(if $(IS_DEP),$(filter-out -Werror,$(ERLC_OPTS)),$(ERLC_OPTS)) -o ebin/ \
+		-pa ebin/ -I include/ $(filter-out $(ERLC_EXCLUDE_PATHS),$(COMPILE_FIRST_PATHS) $(1))
+endef
+
+ebin/$(PROJECT).app:: $(ERL_FILES) $(CORE_FILES) $(wildcard src/$(PROJECT).app.src)
+	$(eval FILES_TO_COMPILE := $(filter-out src/$(PROJECT).app.src,$?))
+	$(if $(strip $(FILES_TO_COMPILE)),$(call compile_erl,$(FILES_TO_COMPILE)))
+	$(eval GITDESCRIBE := $(shell git describe --dirty --abbrev=7 --tags --always --first-parent 2>/dev/null || true))
+	$(eval MODULES := $(patsubst %,'%',$(sort $(notdir $(basename \
+		$(filter-out $(ERLC_EXCLUDE_PATHS),$(ERL_FILES) $(CORE_FILES) $(BEAM_FILES)))))))
+ifeq ($(wildcard src/$(PROJECT).app.src),)
+	$(app_verbose) printf '$(subst %,%%,$(subst $(newline),\n,$(subst ','\'',$(call app_file,$(GITDESCRIBE),$(MODULES)))))' \
+		> ebin/$(PROJECT).app
+else
+	$(verbose) if [ -z "$$(grep -e '^[^%]*{\s*modules\s*,' src/$(PROJECT).app.src)" ]; then \
+		echo "Empty modules entry not found in $(PROJECT).app.src. Please consult the erlang.mk README for instructions." >&2; \
+		exit 1; \
+	fi
+	$(appsrc_verbose) cat src/$(PROJECT).app.src \
+		| sed "s/{[[:space:]]*modules[[:space:]]*,[[:space:]]*\[\]}/{modules, \[$(call comma_list,$(MODULES))\]}/" \
+		| sed "s/{id,[[:space:]]*\"git\"}/{id, \"$(subst /,\/,$(GITDESCRIBE))\"}/" \
+		> ebin/$(PROJECT).app
 endif
 endif
 
 
 clean:: clean-app
 clean:: clean-app
 
 
 clean-app:
 clean-app:
-	$(gen_verbose) rm -rf ebin/ priv/mibs/ \
+	$(gen_verbose) rm -rf $(PROJECT).d ebin/ priv/mibs/ $(XRL_ERL_FILES) $(YRL_ERL_FILES) \
-		$(addprefix include/,$(addsuffix .hrl,$(notdir $(basename $(wildcard mibs/*.mib)))))
+		$(addprefix include/,$(patsubst %.mib,%.hrl,$(notdir $(MIB_FILES)))) \
+		$(addprefix include/,$(patsubst %.asn1,%.hrl,$(notdir $(ASN1_FILES)))) \
+		$(addprefix include/,$(patsubst %.asn1,%.asn1db,$(notdir $(ASN1_FILES)))) \
+		$(addprefix src/,$(patsubst %.asn1,%.erl,$(notdir $(ASN1_FILES))))
 
 
+endif
+
+# Copyright (c) 2016, Loïc Hoguin <essen@ninenines.eu>
 # Copyright (c) 2015, Viktor Söderqvist <viktor@zuiderkwast.se>
 # Copyright (c) 2015, Viktor Söderqvist <viktor@zuiderkwast.se>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
@@ -877,10 +544,10 @@ ifneq ($(SKIP_DEPS),)
 doc-deps:
 doc-deps:
 else
 else
 doc-deps: $(ALL_DOC_DEPS_DIRS)
 doc-deps: $(ALL_DOC_DEPS_DIRS)
-	@for dep in $(ALL_DOC_DEPS_DIRS) ; do $(MAKE) -C $$dep; done
+	$(verbose) set -e; for dep in $(ALL_DOC_DEPS_DIRS) ; do $(MAKE) -C $$dep; done
 endif
 endif
 
 
-# Copyright (c) 2015, Loïc Hoguin <essen@ninenines.eu>
+# Copyright (c) 2015-2016, Loïc Hoguin <essen@ninenines.eu>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
 .PHONY: test-deps test-dir test-build clean-test-dir
 .PHONY: test-deps test-dir test-build clean-test-dir
@@ -902,24 +569,29 @@ ifneq ($(SKIP_DEPS),)
 test-deps:
 test-deps:
 else
 else
 test-deps: $(ALL_TEST_DEPS_DIRS)
 test-deps: $(ALL_TEST_DEPS_DIRS)
-	@for dep in $(ALL_TEST_DEPS_DIRS) ; do $(MAKE) -C $$dep; done
+	$(verbose) set -e; for dep in $(ALL_TEST_DEPS_DIRS) ; do $(MAKE) -C $$dep IS_DEP=1; done
 endif
 endif
 
 
-ifneq ($(strip $(TEST_DIR)),)
+ifneq ($(wildcard $(TEST_DIR)),)
 test-dir:
 test-dir:
 	$(gen_verbose) erlc -v $(TEST_ERLC_OPTS) -I include/ -o $(TEST_DIR) \
 	$(gen_verbose) erlc -v $(TEST_ERLC_OPTS) -I include/ -o $(TEST_DIR) \
-		$(wildcard $(TEST_DIR)/*.erl $(TEST_DIR)/*/*.erl) -pa ebin/
+		$(call core_find,$(TEST_DIR)/,*.erl) -pa ebin/
 endif
 endif
 
 
-ifeq ($(wildcard ebin/test),)
+ifeq ($(wildcard src),)
 test-build:: ERLC_OPTS=$(TEST_ERLC_OPTS)
 test-build:: ERLC_OPTS=$(TEST_ERLC_OPTS)
 test-build:: clean deps test-deps
 test-build:: clean deps test-deps
-	@$(MAKE) --no-print-directory app-build test-dir ERLC_OPTS="$(TEST_ERLC_OPTS)"
+	$(verbose) $(MAKE) --no-print-directory test-dir ERLC_OPTS="$(TEST_ERLC_OPTS)"
+else
+ifeq ($(wildcard ebin/test),)
+test-build:: ERLC_OPTS=$(TEST_ERLC_OPTS)
+test-build:: clean deps test-deps $(PROJECT).d
+	$(verbose) $(MAKE) --no-print-directory app-build test-dir ERLC_OPTS="$(TEST_ERLC_OPTS)"
 	$(gen_verbose) touch ebin/test
 	$(gen_verbose) touch ebin/test
 else
 else
 test-build:: ERLC_OPTS=$(TEST_ERLC_OPTS)
 test-build:: ERLC_OPTS=$(TEST_ERLC_OPTS)
-test-build:: deps test-deps
+test-build:: deps test-deps $(PROJECT).d
-	@$(MAKE) --no-print-directory app-build test-dir ERLC_OPTS="$(TEST_ERLC_OPTS)"
+	$(verbose) $(MAKE) --no-print-directory app-build test-dir ERLC_OPTS="$(TEST_ERLC_OPTS)"
 endif
 endif
 
 
 clean:: clean-test-dir
 clean:: clean-test-dir
@@ -928,709 +600,58 @@ clean-test-dir:
 ifneq ($(wildcard $(TEST_DIR)/*.beam),)
 ifneq ($(wildcard $(TEST_DIR)/*.beam),)
 	$(gen_verbose) rm -f $(TEST_DIR)/*.beam
 	$(gen_verbose) rm -f $(TEST_DIR)/*.beam
 endif
 endif
+endif
 
 
-# Copyright (c) 2015, Loïc Hoguin <essen@ninenines.eu>
+# Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
-.PHONY: asciidoc asciidoc-guide asciidoc-manual install-asciidoc distclean-asciidoc
+.PHONY: plt distclean-plt dialyze
 
 
-MAN_INSTALL_PATH ?= /usr/local/share/man
+# Configuration.
-MAN_SECTIONS ?= 3 7
 
 
-docs:: asciidoc
+DIALYZER_PLT ?= $(CURDIR)/.$(PROJECT).plt
+export DIALYZER_PLT
 
 
-asciidoc: distclean-asciidoc doc-deps asciidoc-guide asciidoc-manual
+PLT_APPS ?=
+DIALYZER_DIRS ?= --src -r $(wildcard src) $(ALL_APPS_DIRS)
+DIALYZER_OPTS ?= -Werror_handling -Wrace_conditions -Wunmatched_returns # -Wunderspecs
 
 
-ifeq ($(wildcard doc/src/guide/book.asciidoc),)
+# Core targets.
-asciidoc-guide:
-else
-asciidoc-guide:
-	a2x -v -f pdf doc/src/guide/book.asciidoc && mv doc/src/guide/book.pdf doc/guide.pdf
-	a2x -v -f chunked doc/src/guide/book.asciidoc && mv doc/src/guide/book.chunked/ doc/html/
-endif
 
 
-ifeq ($(wildcard doc/src/manual/*.asciidoc),)
+check:: dialyze
-asciidoc-manual:
-else
-asciidoc-manual:
-	for f in doc/src/manual/*.asciidoc ; do \
-		a2x -v -f manpage $$f ; \
-	done
-	for s in $(MAN_SECTIONS); do \
-		mkdir -p doc/man$$s/ ; \
-		mv doc/src/manual/*.$$s doc/man$$s/ ; \
-		gzip doc/man$$s/*.$$s ; \
-	done
-
-install-docs:: install-asciidoc
-
-install-asciidoc: asciidoc-manual
-	for s in $(MAN_SECTIONS); do \
-		mkdir -p $(MAN_INSTALL_PATH)/man$$s/ ; \
-		install -g 0 -o 0 -m 0644 doc/man$$s/*.gz $(MAN_INSTALL_PATH)/man$$s/ ; \
-	done
-endif
 
 
-distclean:: distclean-asciidoc
+distclean:: distclean-plt
 
 
-distclean-asciidoc:
+help::
-	$(gen_verbose) rm -rf doc/html/ doc/guide.pdf doc/man3/ doc/man7/
+	$(verbose) printf "%s\n" "" \
+		"Dialyzer targets:" \
+		"  plt         Build a PLT file for this project" \
+		"  dialyze     Analyze the project using Dialyzer"
 
 
-# Copyright (c) 2014-2015, Loïc Hoguin <essen@ninenines.eu>
+# Plugin-specific targets.
-# This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
-.PHONY: bootstrap bootstrap-lib bootstrap-rel new list-templates
+define filter_opts.erl
+	Opts = init:get_plain_arguments(),
+	{Filtered, _} = lists:foldl(fun
+		(O,                         {Os, true}) -> {[O|Os], false};
+		(O = "-D",                  {Os, _})    -> {[O|Os], true};
+		(O = [\\$$-, \\$$D, _ | _], {Os, _})    -> {[O|Os], false};
+		(O = "-I",                  {Os, _})    -> {[O|Os], true};
+		(O = [\\$$-, \\$$I, _ | _], {Os, _})    -> {[O|Os], false};
+		(O = "-pa",                 {Os, _})    -> {[O|Os], true};
+		(_,                         Acc)        -> Acc
+	end, {[], false}, Opts),
+	io:format("~s~n", [string:join(lists:reverse(Filtered), " ")]),
+	halt().
+endef
 
 
-# Core targets.
+$(DIALYZER_PLT): deps app
+	$(eval DEPS_LOG := $(shell test -f $(ERLANG_MK_TMP)/deps.log && \
+		while read p; do test -d $$p/ebin && echo $$p/ebin; done <$(ERLANG_MK_TMP)/deps.log))
+	$(verbose) dialyzer --build_plt --apps erts kernel stdlib \
+		$(PLT_APPS) $(OTP_DEPS) $(LOCAL_DEPS) $(DEPS_LOG)
 
 
-help::
+plt: $(DIALYZER_PLT)
-	@printf "%s\n" "" \
-		"Bootstrap targets:" \
-		"  bootstrap          Generate a skeleton of an OTP application" \
-		"  bootstrap-lib      Generate a skeleton of an OTP library" \
-		"  bootstrap-rel      Generate the files needed to build a release" \
-		"  new t=TPL n=NAME   Generate a module NAME based on the template TPL" \
-		"  list-templates     List available templates"
-
-# Bootstrap templates.
-
-define bs_appsrc
-{application, $(PROJECT), [
-	{description, ""},
-	{vsn, "0.1.0"},
-	{id, "git"},
-	{modules, []},
-	{registered, []},
-	{applications, [
-		kernel,
-		stdlib
-	]},
-	{mod, {$(PROJECT)_app, []}},
-	{env, []}
-]}.
-endef
-
-define bs_appsrc_lib
-{application, $(PROJECT), [
-	{description, ""},
-	{vsn, "0.1.0"},
-	{id, "git"},
-	{modules, []},
-	{registered, []},
-	{applications, [
-		kernel,
-		stdlib
-	]}
-]}.
-endef
-
-define bs_Makefile
-PROJECT = $(PROJECT)
-include erlang.mk
-endef
-
-define bs_app
--module($(PROJECT)_app).
--behaviour(application).
-
--export([start/2]).
--export([stop/1]).
-
-start(_Type, _Args) ->
-	$(PROJECT)_sup:start_link().
-
-stop(_State) ->
-	ok.
-endef
-
-define bs_relx_config
-{release, {$(PROJECT)_release, "1"}, [$(PROJECT)]}.
-{extended_start_script, true}.
-{sys_config, "rel/sys.config"}.
-{vm_args, "rel/vm.args"}.
-endef
-
-define bs_sys_config
-[
-].
-endef
-
-define bs_vm_args
--name $(PROJECT)@127.0.0.1
--setcookie $(PROJECT)
--heart
-endef
-
-# Normal templates.
-
-define tpl_supervisor
--module($(n)).
--behaviour(supervisor).
-
--export([start_link/0]).
--export([init/1]).
-
-start_link() ->
-	supervisor:start_link({local, ?MODULE}, ?MODULE, []).
-
-init([]) ->
-	Procs = [],
-	{ok, {{one_for_one, 1, 5}, Procs}}.
-endef
-
-define tpl_gen_server
--module($(n)).
--behaviour(gen_server).
-
-%% API.
--export([start_link/0]).
-
-%% gen_server.
--export([init/1]).
--export([handle_call/3]).
--export([handle_cast/2]).
--export([handle_info/2]).
--export([terminate/2]).
--export([code_change/3]).
-
--record(state, {
-}).
-
-%% API.
-
--spec start_link() -> {ok, pid()}.
-start_link() ->
-	gen_server:start_link(?MODULE, [], []).
-
-%% gen_server.
-
-init([]) ->
-	{ok, #state{}}.
-
-handle_call(_Request, _From, State) ->
-	{reply, ignored, State}.
-
-handle_cast(_Msg, State) ->
-	{noreply, State}.
-
-handle_info(_Info, State) ->
-	{noreply, State}.
-
-terminate(_Reason, _State) ->
-	ok.
-
-code_change(_OldVsn, State, _Extra) ->
-	{ok, State}.
-endef
-
-define tpl_cowboy_http
--module($(n)).
--behaviour(cowboy_http_handler).
-
--export([init/3]).
--export([handle/2]).
--export([terminate/3]).
-
--record(state, {
-}).
-
-init(_, Req, _Opts) ->
-	{ok, Req, #state{}}.
-
-handle(Req, State=#state{}) ->
-	{ok, Req2} = cowboy_req:reply(200, Req),
-	{ok, Req2, State}.
-
-terminate(_Reason, _Req, _State) ->
-	ok.
-endef
-
-define tpl_gen_fsm
--module($(n)).
--behaviour(gen_fsm).
-
-%% API.
--export([start_link/0]).
-
-%% gen_fsm.
--export([init/1]).
--export([state_name/2]).
--export([handle_event/3]).
--export([state_name/3]).
--export([handle_sync_event/4]).
--export([handle_info/3]).
--export([terminate/3]).
--export([code_change/4]).
-
--record(state, {
-}).
-
-%% API.
-
--spec start_link() -> {ok, pid()}.
-start_link() ->
-	gen_fsm:start_link(?MODULE, [], []).
-
-%% gen_fsm.
-
-init([]) ->
-	{ok, state_name, #state{}}.
-
-state_name(_Event, StateData) ->
-	{next_state, state_name, StateData}.
-
-handle_event(_Event, StateName, StateData) ->
-	{next_state, StateName, StateData}.
-
-state_name(_Event, _From, StateData) ->
-	{reply, ignored, state_name, StateData}.
-
-handle_sync_event(_Event, _From, StateName, StateData) ->
-	{reply, ignored, StateName, StateData}.
-
-handle_info(_Info, StateName, StateData) ->
-	{next_state, StateName, StateData}.
-
-terminate(_Reason, _StateName, _StateData) ->
-	ok.
-
-code_change(_OldVsn, StateName, StateData, _Extra) ->
-	{ok, StateName, StateData}.
-endef
-
-define tpl_cowboy_loop
--module($(n)).
--behaviour(cowboy_loop_handler).
-
--export([init/3]).
--export([info/3]).
--export([terminate/3]).
-
--record(state, {
-}).
-
-init(_, Req, _Opts) ->
-	{loop, Req, #state{}, 5000, hibernate}.
-
-info(_Info, Req, State) ->
-	{loop, Req, State, hibernate}.
-
-terminate(_Reason, _Req, _State) ->
-	ok.
-endef
-
-define tpl_cowboy_rest
--module($(n)).
-
--export([init/3]).
--export([content_types_provided/2]).
--export([get_html/2]).
-
-init(_, _Req, _Opts) ->
-	{upgrade, protocol, cowboy_rest}.
-
-content_types_provided(Req, State) ->
-	{[{{<<"text">>, <<"html">>, '*'}, get_html}], Req, State}.
-
-get_html(Req, State) ->
-	{<<"<html><body>This is REST!</body></html>">>, Req, State}.
-endef
-
-define tpl_cowboy_ws
--module($(n)).
--behaviour(cowboy_websocket_handler).
-
--export([init/3]).
--export([websocket_init/3]).
--export([websocket_handle/3]).
--export([websocket_info/3]).
--export([websocket_terminate/3]).
-
--record(state, {
-}).
-
-init(_, _, _) ->
-	{upgrade, protocol, cowboy_websocket}.
-
-websocket_init(_, Req, _Opts) ->
-	Req2 = cowboy_req:compact(Req),
-	{ok, Req2, #state{}}.
-
-websocket_handle({text, Data}, Req, State) ->
-	{reply, {text, Data}, Req, State};
-websocket_handle({binary, Data}, Req, State) ->
-	{reply, {binary, Data}, Req, State};
-websocket_handle(_Frame, Req, State) ->
-	{ok, Req, State}.
-
-websocket_info(_Info, Req, State) ->
-	{ok, Req, State}.
-
-websocket_terminate(_Reason, _Req, _State) ->
-	ok.
-endef
-
-define tpl_ranch_protocol
--module($(n)).
--behaviour(ranch_protocol).
-
--export([start_link/4]).
--export([init/4]).
-
--type opts() :: [].
--export_type([opts/0]).
-
--record(state, {
-	socket :: inet:socket(),
-	transport :: module()
-}).
-
-start_link(Ref, Socket, Transport, Opts) ->
-	Pid = spawn_link(?MODULE, init, [Ref, Socket, Transport, Opts]),
-	{ok, Pid}.
-
--spec init(ranch:ref(), inet:socket(), module(), opts()) -> ok.
-init(Ref, Socket, Transport, _Opts) ->
-	ok = ranch:accept_ack(Ref),
-	loop(#state{socket=Socket, transport=Transport}).
-
-loop(State) ->
-	loop(State).
-endef
-
-# Plugin-specific targets.
-
-define render_template
-	@echo "$${$(1)}" > $(2)
-endef
-
-$(foreach template,$(filter bs_%,$(.VARIABLES)),$(eval export $(template)))
-$(foreach template,$(filter tpl_%,$(.VARIABLES)),$(eval export $(template)))
-
-bootstrap:
-ifneq ($(wildcard src/),)
-	$(error Error: src/ directory already exists)
-endif
-	$(call render_template,bs_Makefile,Makefile)
-	@mkdir src/
-	$(call render_template,bs_appsrc,src/$(PROJECT).app.src)
-	$(call render_template,bs_app,src/$(PROJECT)_app.erl)
-	$(eval n := $(PROJECT)_sup)
-	$(call render_template,tpl_supervisor,src/$(PROJECT)_sup.erl)
-
-bootstrap-lib:
-ifneq ($(wildcard src/),)
-	$(error Error: src/ directory already exists)
-endif
-	$(call render_template,bs_Makefile,Makefile)
-	@mkdir src/
-	$(call render_template,bs_appsrc_lib,src/$(PROJECT).app.src)
-
-bootstrap-rel:
-ifneq ($(wildcard relx.config),)
-	$(error Error: relx.config already exists)
-endif
-ifneq ($(wildcard rel/),)
-	$(error Error: rel/ directory already exists)
-endif
-	$(call render_template,bs_relx_config,relx.config)
-	@mkdir rel/
-	$(call render_template,bs_sys_config,rel/sys.config)
-	$(call render_template,bs_vm_args,rel/vm.args)
-
-new:
-ifeq ($(wildcard src/),)
-	$(error Error: src/ directory does not exist)
-endif
-ifndef t
-	$(error Usage: $(MAKE) new t=TEMPLATE n=NAME)
-endif
-ifndef tpl_$(t)
-	$(error Unknown template)
-endif
-ifndef n
-	$(error Usage: $(MAKE) new t=TEMPLATE n=NAME)
-endif
-	$(call render_template,tpl_$(t),src/$(n).erl)
-
-list-templates:
-	@echo Available templates: $(sort $(patsubst tpl_%,%,$(filter tpl_%,$(.VARIABLES))))
-
-# Copyright (c) 2014-2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: clean-c_src distclean-c_src-env
-
-# Configuration.
-
-C_SRC_DIR ?= $(CURDIR)/c_src
-C_SRC_ENV ?= $(C_SRC_DIR)/env.mk
-C_SRC_OUTPUT ?= $(CURDIR)/priv/$(PROJECT).so
-C_SRC_TYPE ?= shared
-
-# System type and C compiler/flags.
-
-ifeq ($(PLATFORM),darwin)
-	CC ?= cc
-	CFLAGS ?= -O3 -std=c99 -arch x86_64 -finline-functions -Wall -Wmissing-prototypes
-	CXXFLAGS ?= -O3 -arch x86_64 -finline-functions -Wall
-	LDFLAGS ?= -arch x86_64 -flat_namespace -undefined suppress
-else ifeq ($(PLATFORM),freebsd)
-	CC ?= cc
-	CFLAGS ?= -O3 -std=c99 -finline-functions -Wall -Wmissing-prototypes
-	CXXFLAGS ?= -O3 -finline-functions -Wall
-else ifeq ($(PLATFORM),linux)
-	CC ?= gcc
-	CFLAGS ?= -O3 -std=c99 -finline-functions -Wall -Wmissing-prototypes
-	CXXFLAGS ?= -O3 -finline-functions -Wall
-endif
-
-CFLAGS += -fPIC -I $(ERTS_INCLUDE_DIR) -I $(ERL_INTERFACE_INCLUDE_DIR)
-CXXFLAGS += -fPIC -I $(ERTS_INCLUDE_DIR) -I $(ERL_INTERFACE_INCLUDE_DIR)
-
-LDLIBS += -L $(ERL_INTERFACE_LIB_DIR) -lerl_interface -lei
-
-ifeq ($(C_SRC_TYPE),shared)
-LDFLAGS += -shared
-endif
-
-# Verbosity.
-
-c_verbose_0 = @echo " C     " $(?F);
-c_verbose = $(c_verbose_$(V))
-
-cpp_verbose_0 = @echo " CPP   " $(?F);
-cpp_verbose = $(cpp_verbose_$(V))
-
-link_verbose_0 = @echo " LD    " $(@F);
-link_verbose = $(link_verbose_$(V))
-
-# Targets.
-
-ifeq ($(wildcard $(C_SRC_DIR)),)
-else ifneq ($(wildcard $(C_SRC_DIR)/Makefile),)
-app:: app-c_src
-
-test-build:: app-c_src
-
-app-c_src:
-	$(MAKE) -C $(C_SRC_DIR)
-
-clean::
-	$(MAKE) -C $(C_SRC_DIR) clean
-
-else
-
-ifeq ($(SOURCES),)
-SOURCES := $(shell find $(C_SRC_DIR) -type f \( -name "*.c" -o -name "*.C" -o -name "*.cc" -o -name "*.cpp" \))
-endif
-OBJECTS = $(addsuffix .o, $(basename $(SOURCES)))
-
-COMPILE_C = $(c_verbose) $(CC) $(CFLAGS) $(CPPFLAGS) -c
-COMPILE_CPP = $(cpp_verbose) $(CXX) $(CXXFLAGS) $(CPPFLAGS) -c
-
-app:: $(C_SRC_ENV) $(C_SRC_OUTPUT)
-
-test-build:: $(C_SRC_ENV) $(C_SRC_OUTPUT)
-
-$(C_SRC_OUTPUT): $(OBJECTS)
-	@mkdir -p priv/
-	$(link_verbose) $(CC) $(OBJECTS) $(LDFLAGS) $(LDLIBS) -o $(C_SRC_OUTPUT)
-
-%.o: %.c
-	$(COMPILE_C) $(OUTPUT_OPTION) $<
-
-%.o: %.cc
-	$(COMPILE_CPP) $(OUTPUT_OPTION) $<
-
-%.o: %.C
-	$(COMPILE_CPP) $(OUTPUT_OPTION) $<
-
-%.o: %.cpp
-	$(COMPILE_CPP) $(OUTPUT_OPTION) $<
-
-clean:: clean-c_src
-
-clean-c_src:
-	$(gen_verbose) rm -f $(C_SRC_OUTPUT) $(OBJECTS)
-
-endif
-
-ifneq ($(wildcard $(C_SRC_DIR)),)
-$(C_SRC_ENV):
-	@$(ERL) -eval "file:write_file(\"$(C_SRC_ENV)\", \
-		io_lib:format( \
-			\"ERTS_INCLUDE_DIR ?= ~s/erts-~s/include/~n\" \
-			\"ERL_INTERFACE_INCLUDE_DIR ?= ~s~n\" \
-			\"ERL_INTERFACE_LIB_DIR ?= ~s~n\", \
-			[code:root_dir(), erlang:system_info(version), \
-			code:lib_dir(erl_interface, include), \
-			code:lib_dir(erl_interface, lib)])), \
-		halt()."
-
-distclean:: distclean-c_src-env
-
-distclean-c_src-env:
-	$(gen_verbose) rm -f $(C_SRC_ENV)
-
--include $(C_SRC_ENV)
-endif
-
-# Copyright (c) 2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: ci ci-setup distclean-kerl
-
-KERL ?= $(CURDIR)/kerl
-export KERL
-
-KERL_URL ?= https://raw.githubusercontent.com/yrashk/kerl/master/kerl
-
-OTP_GIT ?= https://github.com/erlang/otp
-
-CI_INSTALL_DIR ?= $(HOME)/erlang
-CI_OTP ?=
-
-ifeq ($(strip $(CI_OTP)),)
-ci::
-else
-ci:: $(KERL) $(addprefix ci-,$(CI_OTP))
-
-ci-setup::
-
-ci_verbose_0 = @echo " CI    " $(1);
-ci_verbose = $(ci_verbose_$(V))
-
-define ci_target
-ci-$(1): $(CI_INSTALL_DIR)/$(1)
-	-$(ci_verbose) \
-		PATH="$(CI_INSTALL_DIR)/$(1)/bin:$(PATH)" \
-		CI_OTP_RELEASE="$(1)" \
-		CT_OPTS="-label $(1)" \
-		$(MAKE) clean ci-setup tests
-endef
-
-$(foreach otp,$(CI_OTP),$(eval $(call ci_target,$(otp))))
-
-define ci_otp_target
-$(CI_INSTALL_DIR)/$(1):
-	$(KERL) build git $(OTP_GIT) $(1) $(1)
-	$(KERL) install $(1) $(CI_INSTALL_DIR)/$(1)
-endef
-
-$(foreach otp,$(CI_OTP),$(eval $(call ci_otp_target,$(otp))))
-
-define kerl_fetch
-	$(call core_http_get,$(KERL),$(KERL_URL))
-	chmod +x $(KERL)
-endef
-
-$(KERL):
-	@$(call kerl_fetch)
-
-help::
-	@printf "%s\n" "" \
-		"Continuous Integration targets:" \
-		"  ci          Run '$(MAKE) tests' on all configured Erlang versions." \
-		"" \
-		"The CI_OTP variable must be defined with the Erlang versions" \
-		"that must be tested. For example: CI_OTP = OTP-17.3.4 OTP-17.5.3"
-
-distclean:: distclean-kerl
-
-distclean-kerl:
-	$(gen_verbose) rm -rf $(KERL)
-endif
-
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: ct distclean-ct
-
-# Configuration.
-
-CT_OPTS ?=
-ifneq ($(wildcard $(TEST_DIR)),)
-	CT_SUITES ?= $(sort $(subst _SUITE.erl,,$(shell find $(TEST_DIR) -type f -name \*_SUITE.erl -exec basename {} \;)))
-else
-	CT_SUITES ?=
-endif
-
-# Core targets.
-
-tests:: ct
-
-distclean:: distclean-ct
-
-help::
-	@printf "%s\n" "" \
-		"Common_test targets:" \
-		"  ct          Run all the common_test suites for this project" \
-		"" \
-		"All your common_test suites have their associated targets." \
-		"A suite named http_SUITE can be ran using the ct-http target."
-
-# Plugin-specific targets.
-
-CT_RUN = ct_run \
-	-no_auto_compile \
-	-noinput \
-	-pa $(CURDIR)/ebin $(DEPS_DIR)/*/ebin $(TEST_DIR) \
-	-dir $(TEST_DIR) \
-	-logdir $(CURDIR)/logs
-
-ifeq ($(CT_SUITES),)
-ct:
-else
-ct: test-build
-	@mkdir -p $(CURDIR)/logs/
-	$(gen_verbose) $(CT_RUN) -suite $(addsuffix _SUITE,$(CT_SUITES)) $(CT_OPTS)
-endif
-
-define ct_suite_target
-ct-$(1): test-build
-	@mkdir -p $(CURDIR)/logs/
-	$(gen_verbose) $(CT_RUN) -suite $(addsuffix _SUITE,$(1)) $(CT_OPTS)
-endef
-
-$(foreach test,$(CT_SUITES),$(eval $(call ct_suite_target,$(test))))
-
-distclean-ct:
-	$(gen_verbose) rm -rf $(CURDIR)/logs/
-
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: plt distclean-plt dialyze
-
-# Configuration.
-
-DIALYZER_PLT ?= $(CURDIR)/.$(PROJECT).plt
-export DIALYZER_PLT
-
-PLT_APPS ?=
-DIALYZER_DIRS ?= --src -r src
-DIALYZER_OPTS ?= -Werror_handling -Wrace_conditions \
-	-Wunmatched_returns # -Wunderspecs
-
-# Core targets.
-
-check:: dialyze
-
-distclean:: distclean-plt
-
-help::
-	@printf "%s\n" "" \
-		"Dialyzer targets:" \
-		"  plt         Build a PLT file for this project" \
-		"  dialyze     Analyze the project using Dialyzer"
-
-# Plugin-specific targets.
-
-$(DIALYZER_PLT): deps app
-	@dialyzer --build_plt --apps erts kernel stdlib $(PLT_APPS) $(ALL_DEPS_DIRS)
-
-plt: $(DIALYZER_PLT)
 
 
 distclean-plt:
 distclean-plt:
 	$(gen_verbose) rm -f $(DIALYZER_PLT)
 	$(gen_verbose) rm -f $(DIALYZER_PLT)
@@ -1640,9 +661,9 @@ dialyze:
 else
 else
 dialyze: $(DIALYZER_PLT)
 dialyze: $(DIALYZER_PLT)
 endif
 endif
-	@dialyzer --no_native $(DIALYZER_DIRS) $(DIALYZER_OPTS)
+	$(verbose) dialyzer --no_native `$(ERL) -eval "$(subst $(newline),,$(subst ",\",$(call filter_opts.erl)))" -extra $(ERLC_OPTS)` $(DIALYZER_DIRS) $(DIALYZER_OPTS)
 
 
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
+# Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
 .PHONY: distclean-edoc edoc
 .PHONY: distclean-edoc edoc
@@ -1650,289 +671,105 @@ endif
 # Configuration.
 # Configuration.
 
 
 EDOC_OPTS ?=
 EDOC_OPTS ?=
+EDOC_SRC_DIRS ?=
+
+define edoc.erl
+	SrcPaths = lists:foldl(fun(P, Acc) ->
+		filelib:wildcard(atom_to_list(P) ++ "/{src,c_src}") ++ Acc
+	end, [], [$(call comma_list,$(patsubst %,'%',$(EDOC_SRC_DIRS)))]),
+	DefaultOpts = [{source_path, SrcPaths}, {subpackages, false}],
+	edoc:application($(1), ".", [$(2)] ++ DefaultOpts),
+	halt(0).
+endef
 
 
 # Core targets.
 # Core targets.
 
 
-docs:: distclean-edoc edoc
+ifneq ($(strip $(EDOC_SRC_DIRS)$(wildcard doc/overview.edoc)),)
+docs:: edoc
+endif
 
 
 distclean:: distclean-edoc
 distclean:: distclean-edoc
 
 
 # Plugin-specific targets.
 # Plugin-specific targets.
 
 
-edoc: doc-deps
+edoc: distclean-edoc doc-deps
-	$(gen_verbose) $(ERL) -eval 'edoc:application($(PROJECT), ".", [$(EDOC_OPTS)]), halt().'
+	$(gen_verbose) $(call erlang,$(call edoc.erl,$(PROJECT),$(EDOC_OPTS)))
 
 
 distclean-edoc:
 distclean-edoc:
 	$(gen_verbose) rm -f doc/*.css doc/*.html doc/*.png doc/edoc-info
 	$(gen_verbose) rm -f doc/*.css doc/*.html doc/*.png doc/edoc-info
 
 
-# Copyright (c) 2014, Juan Facorro <juan@inaka.net>
+# Copyright (c) 2015-2016, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: elvis distclean-elvis
-
-# Configuration.
-
-ELVIS_CONFIG ?= $(CURDIR)/elvis.config
-
-ELVIS ?= $(CURDIR)/elvis
-export ELVIS
-
-ELVIS_URL ?= https://github.com/inaka/elvis/releases/download/0.2.3/elvis
-ELVIS_CONFIG_URL ?= https://github.com/inaka/elvis/releases/download/0.2.3/elvis.config
-ELVIS_OPTS ?=
-
-# Core targets.
-
-help::
-	@printf "%s\n" "" \
-		"Elvis targets:" \
-		"  elvis       Run Elvis using the local elvis.config or download the default otherwise"
-
-distclean:: distclean-elvis
-
-# Plugin-specific targets.
-
-$(ELVIS):
-	@$(call core_http_get,$(ELVIS),$(ELVIS_URL))
-	@chmod +x $(ELVIS)
-
-$(ELVIS_CONFIG):
-	@$(call core_http_get,$(ELVIS_CONFIG),$(ELVIS_CONFIG_URL))
-
-elvis: $(ELVIS) $(ELVIS_CONFIG)
-	@$(ELVIS) rock -c $(ELVIS_CONFIG) $(ELVIS_OPTS)
-
-distclean-elvis:
-	$(gen_verbose) rm -rf $(ELVIS)
-
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-# Configuration.
-
-DTL_FULL_PATH ?= 0
-
-# Verbosity.
-
-dtl_verbose_0 = @echo " DTL   " $(filter %.dtl,$(?F));
-dtl_verbose = $(dtl_verbose_$(V))
-
-# Core targets.
-
-define compile_erlydtl
-	$(dtl_verbose) $(ERL) -pa ebin/ $(DEPS_DIR)/erlydtl/ebin/ -eval ' \
-		Compile = fun(F) -> \
-			S = fun (1) -> re:replace(filename:rootname(string:sub_string(F, 11), ".dtl"), "/",  "_",  [{return, list}, global]); \
-				(0) -> filename:basename(F, ".dtl") \
-			end, \
-			Module = list_to_atom(string:to_lower(S($(DTL_FULL_PATH))) ++ "_dtl"), \
-			{ok, _} = erlydtl:compile(F, Module, [{out_dir, "ebin/"}, return_errors, {doc_root, "templates"}]) \
-		end, \
-		_ = [Compile(F) || F <- string:tokens("$(1)", " ")], \
-		halt().'
-endef
-
-ifneq ($(wildcard src/),)
-ebin/$(PROJECT).app:: $(shell find templates -type f -name \*.dtl 2>/dev/null)
-	$(if $(strip $?),$(call compile_erlydtl,$?))
-endif
-
-# Copyright (c) 2014 Dave Cottlehuber <dch@skunkwerks.at>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: distclean-escript escript
-
-# Configuration.
-
-ESCRIPT_NAME ?= $(PROJECT)
-ESCRIPT_COMMENT ?= This is an -*- erlang -*- file
-
-ESCRIPT_BEAMS ?= "ebin/*", "deps/*/ebin/*"
-ESCRIPT_SYS_CONFIG ?= "rel/sys.config"
-ESCRIPT_EMU_ARGS ?= -pa . \
-	-sasl errlog_type error \
-	-escript main $(ESCRIPT_NAME)
-ESCRIPT_SHEBANG ?= /usr/bin/env escript
-ESCRIPT_STATIC ?= "deps/*/priv/**", "priv/**"
-
-# Core targets.
-
-distclean:: distclean-escript
-
-help::
-	@printf "%s\n" "" \
-		"Escript targets:" \
-		"  escript     Build an executable escript archive" \
-
-# Plugin-specific targets.
-
-# Based on https://github.com/synrc/mad/blob/master/src/mad_bundle.erl
-# Copyright (c) 2013 Maxim Sokhatsky, Synrc Research Center
-# Modified MIT License, https://github.com/synrc/mad/blob/master/LICENSE :
-# Software may only be used for the great good and the true happiness of all
-# sentient beings.
-
-define ESCRIPT_RAW
-'Read = fun(F) -> {ok, B} = file:read_file(filename:absname(F)), B end,'\
-'Files = fun(L) -> A = lists:concat([filelib:wildcard(X)||X<- L ]),'\
-'  [F || F <- A, not filelib:is_dir(F) ] end,'\
-'Squash = fun(L) -> [{filename:basename(F), Read(F) } || F <- L ] end,'\
-'Zip = fun(A, L) -> {ok,{_,Z}} = zip:create(A, L, [{compress,all},memory]), Z end,'\
-'Ez = fun(Escript) ->'\
-'  Static = Files([$(ESCRIPT_STATIC)]),'\
-'  Beams = Squash(Files([$(ESCRIPT_BEAMS), $(ESCRIPT_SYS_CONFIG)])),'\
-'  Archive = Beams ++ [{ "static.gz", Zip("static.gz", Static)}],'\
-'  escript:create(Escript, [ $(ESCRIPT_OPTIONS)'\
-'    {archive, Archive, [memory]},'\
-'    {shebang, "$(ESCRIPT_SHEBANG)"},'\
-'    {comment, "$(ESCRIPT_COMMENT)"},'\
-'    {emu_args, " $(ESCRIPT_EMU_ARGS)"}'\
-'  ]),'\
-'  file:change_mode(Escript, 8#755)'\
-'end,'\
-'Ez("$(ESCRIPT_NAME)"),'\
-'halt().'
-endef
-
-ESCRIPT_COMMAND = $(subst ' ',,$(ESCRIPT_RAW))
-
-escript:: distclean-escript deps app
-	$(gen_verbose) $(ERL) -eval $(ESCRIPT_COMMAND)
-
-distclean-escript:
-	$(gen_verbose) rm -f $(ESCRIPT_NAME)
-
 # Copyright (c) 2014, Enrique Fernandez <enrique.fernandez@erlang-solutions.com>
 # Copyright (c) 2014, Enrique Fernandez <enrique.fernandez@erlang-solutions.com>
-# Copyright (c) 2015, Loïc Hoguin <essen@ninenines.eu>
 # This file is contributed to erlang.mk and subject to the terms of the ISC License.
 # This file is contributed to erlang.mk and subject to the terms of the ISC License.
 
 
-.PHONY: eunit
+.PHONY: eunit apps-eunit
 
 
 # Configuration
 # Configuration
 
 
-# All modules in TEST_DIR
-ifeq ($(strip $(TEST_DIR)),)
-TEST_DIR_MODS = 
-else
-TEST_DIR_MODS = $(notdir $(basename $(shell find $(TEST_DIR) -type f -name *.beam)))
-endif
-
-# All modules in 'ebin'
-EUNIT_EBIN_MODS = $(notdir $(basename $(shell find ebin -type f -name *.beam)))
-# Only those modules in TEST_DIR with no matching module in 'ebin'.
-# This is done to avoid some tests being executed twice.
-EUNIT_MODS = $(filter-out $(patsubst %,%_tests,$(EUNIT_EBIN_MODS)),$(TEST_DIR_MODS))
-TAGGED_EUNIT_TESTS = $(foreach mod,$(EUNIT_EBIN_MODS) $(EUNIT_MODS),{module,$(mod)})
-
 EUNIT_OPTS ?=
 EUNIT_OPTS ?=
-
+EUNIT_ERL_OPTS ?=
-# Utility functions
-
-define str-join
-	$(shell echo '$(strip $(1))' | sed -e "s/ /,/g")
-endef
 
 
 # Core targets.
 # Core targets.
 
 
 tests:: eunit
 tests:: eunit
 
 
 help::
 help::
-	@printf "%s\n" "" \
+	$(verbose) printf "%s\n" "" \
 		"EUnit targets:" \
 		"EUnit targets:" \
 		"  eunit       Run all the EUnit tests for this project"
 		"  eunit       Run all the EUnit tests for this project"
 
 
 # Plugin-specific targets.
 # Plugin-specific targets.
 
 
-EUNIT_RUN_BEFORE ?=
+define eunit.erl
-EUNIT_RUN_AFTER ?=
+	case "$(COVER)" of
-EUNIT_RUN = $(ERL) \
+		"" -> ok;
-	-pa $(TEST_DIR) $(DEPS_DIR)/*/ebin \
+		_ ->
-	-pz ebin \
+			case cover:compile_beam_directory("ebin") of
-	$(EUNIT_RUN_BEFORE) \
+				{error, _} -> halt(1);
-	-eval 'case eunit:test([$(call str-join,$(TAGGED_EUNIT_TESTS))],\
+				_ -> ok
-		[$(EUNIT_OPTS)]) of ok -> ok; error -> halt(1) end.' \
+			end
-	$(EUNIT_RUN_AFTER) \
+	end,
-	-eval 'halt(0).'
+	case eunit:test($1, [$(EUNIT_OPTS)]) of
-
+		ok -> ok;
-eunit: test-build
+		error -> halt(2)
-	$(gen_verbose) $(EUNIT_RUN)
+	end,
-
+	case "$(COVER)" of
-# Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
+		"" -> ok;
-# This file is part of erlang.mk and subject to the terms of the ISC License.
+		_ ->
-
+			cover:export("$(COVER_DATA_DIR)/eunit.coverdata")
-.PHONY: relx-rel distclean-relx-rel distclean-relx run
+	end,
-
+	halt()
-# Configuration.
+endef
-
-RELX_CONFIG ?= $(CURDIR)/relx.config
-
-RELX ?= $(CURDIR)/relx
-export RELX
 
 
-RELX_URL ?= https://github.com/erlware/relx/releases/download/v2.0.0/relx
+EUNIT_ERL_OPTS += -pa $(TEST_DIR) $(DEPS_DIR)/*/ebin $(APPS_DIR)/*/ebin $(CURDIR)/ebin
-RELX_OPTS ?=
-RELX_OUTPUT_DIR ?= _rel
 
 
-ifeq ($(firstword $(RELX_OPTS)),-o)
+ifdef t
-	RELX_OUTPUT_DIR = $(word 2,$(RELX_OPTS))
+ifeq (,$(findstring :,$(t)))
+eunit: test-build cover-data-dir
+	$(gen_verbose) $(call erlang,$(call eunit.erl,['$(t)']),$(EUNIT_ERL_OPTS))
 else
 else
-	RELX_OPTS += -o $(RELX_OUTPUT_DIR)
+eunit: test-build cover-data-dir
-endif
+	$(gen_verbose) $(call erlang,$(call eunit.erl,fun $(t)/0),$(EUNIT_ERL_OPTS))
-
-# Core targets.
-
-ifeq ($(IS_DEP),)
-ifneq ($(wildcard $(RELX_CONFIG)),)
-rel:: distclean-relx-rel relx-rel
 endif
 endif
-endif
-
-distclean:: distclean-relx-rel distclean-relx
-
-# Plugin-specific targets.
-
-define relx_fetch
-	$(call core_http_get,$(RELX),$(RELX_URL))
-	chmod +x $(RELX)
-endef
-
-$(RELX):
-	@$(call relx_fetch)
-
-relx-rel: $(RELX)
-	@$(RELX) -c $(RELX_CONFIG) $(RELX_OPTS)
-
-distclean-relx-rel:
-	$(gen_verbose) rm -rf $(RELX_OUTPUT_DIR)
-
-distclean-relx:
-	$(gen_verbose) rm -rf $(RELX)
-
-# Run target.
-
-ifeq ($(wildcard $(RELX_CONFIG)),)
-run:
 else
 else
+EUNIT_EBIN_MODS = $(notdir $(basename $(ERL_FILES) $(BEAM_FILES)))
+EUNIT_TEST_MODS = $(notdir $(basename $(call core_find,$(TEST_DIR)/,*.erl)))
 
 
-define get_relx_release.erl
+EUNIT_MODS = $(foreach mod,$(EUNIT_EBIN_MODS) $(filter-out \
-	{ok, Config} = file:consult("$(RELX_CONFIG)"),
+	$(patsubst %,%_tests,$(EUNIT_EBIN_MODS)),$(EUNIT_TEST_MODS)),'$(mod)')
-	{release, {Name, _}, _} = lists:keyfind(release, 1, Config),
-	io:format("~s", [Name]),
-	halt(0).
-endef
-
-RELX_RELEASE = `$(call erlang,$(get_relx_release.erl))`
 
 
-run: all
+eunit: test-build $(if $(IS_APP),,apps-eunit) cover-data-dir
-	@$(RELX_OUTPUT_DIR)/$(RELX_RELEASE)/bin/$(RELX_RELEASE) console
+	$(gen_verbose) $(call erlang,$(call eunit.erl,[$(call comma_list,$(EUNIT_MODS))]),$(EUNIT_ERL_OPTS))
-
-help::
-	@printf "%s\n" "" \
-		"Relx targets:" \
-		"  run         Compile the project, build the release and run it"
 
 
+ifneq ($(ALL_APPS_DIRS),)
+apps-eunit:
+	$(verbose) eunit_retcode=0 ; for app in $(ALL_APPS_DIRS); do $(MAKE) -C $$app eunit IS_APP=1; \
+		[ $$? -ne 0 ] && eunit_retcode=1 ; done ; \
+		exit $$eunit_retcode
+endif
 endif
 endif
 
 
+# Copyright (c) 2015-2016, Loïc Hoguin <essen@ninenines.eu>
 # Copyright (c) 2014, M Robert Martin <rob@version2beta.com>
 # Copyright (c) 2014, M Robert Martin <rob@version2beta.com>
 # This file is contributed to erlang.mk and subject to the terms of the ISC License.
 # This file is contributed to erlang.mk and subject to the terms of the ISC License.
 
 
@@ -1940,7 +777,8 @@ endif
 
 
 # Configuration.
 # Configuration.
 
 
-SHELL_PATH ?= -pa $(CURDIR)/ebin $(DEPS_DIR)/*/ebin
+SHELL_ERL ?= erl
+SHELL_PATHS ?= $(CURDIR)/ebin $(APPS_DIR)/*/ebin $(DEPS_DIR)/*/ebin
 SHELL_OPTS ?=
 SHELL_OPTS ?=
 
 
 ALL_SHELL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(SHELL_DEPS))
 ALL_SHELL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(SHELL_DEPS))
@@ -1948,7 +786,7 @@ ALL_SHELL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(SHELL_DEPS))
 # Core targets
 # Core targets
 
 
 help::
 help::
-	@printf "%s\n" "" \
+	$(verbose) printf "%s\n" "" \
 		"Shell targets:" \
 		"Shell targets:" \
 		"  shell       Run an erlang shell with SHELL_OPTS or reasonable default"
 		"  shell       Run an erlang shell with SHELL_OPTS or reasonable default"
 
 
@@ -1957,144 +795,49 @@ help::
 $(foreach dep,$(SHELL_DEPS),$(eval $(call dep_target,$(dep))))
 $(foreach dep,$(SHELL_DEPS),$(eval $(call dep_target,$(dep))))
 
 
 build-shell-deps: $(ALL_SHELL_DEPS_DIRS)
 build-shell-deps: $(ALL_SHELL_DEPS_DIRS)
-	@for dep in $(ALL_SHELL_DEPS_DIRS) ; do $(MAKE) -C $$dep ; done
+	$(verbose) set -e; for dep in $(ALL_SHELL_DEPS_DIRS) ; do $(MAKE) -C $$dep ; done
 
 
 shell: build-shell-deps
 shell: build-shell-deps
-	$(gen_verbose) erl $(SHELL_PATH) $(SHELL_OPTS)
+	$(gen_verbose) $(SHELL_ERL) -pa $(SHELL_PATHS) $(SHELL_OPTS)
-
-# Copyright (c) 2015, Loïc Hoguin <essen@ninenines.eu>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-ifneq ($(wildcard $(DEPS_DIR)/triq),)
-.PHONY: triq
-
-# Targets.
-
-tests:: triq
-
-define triq_check.erl
-	code:add_pathsa(["$(CURDIR)/ebin", "$(DEPS_DIR)/*/ebin"]),
-	try
-		case $(1) of
-			all -> [true] =:= lists:usort([triq:check(M) || M <- [$(MODULES)]]);
-			module -> triq:check($(2));
-			function -> triq:check($(2))
-		end
-	of
-		true -> halt(0);
-		_ -> halt(1)
-	catch error:undef ->
-		io:format("Undefined property or module~n"),
-		halt(0)
-	end.
-endef
 
 
-ifdef t
+# Copyright (c) 2016, Loïc Hoguin <essen@ninenines.eu>
-ifeq (,$(findstring :,$(t)))
+# Copyright (c) 2015, Viktor Söderqvist <viktor@zuiderkwast.se>
-triq: test-build
-	@$(call erlang,$(call triq_check.erl,module,$(t)))
-else
-triq: test-build
-	@echo Testing $(t)/0
-	@$(call erlang,$(call triq_check.erl,function,$(t)()))
-endif
-else
-triq: test-build
-	$(eval MODULES := $(shell find ebin -type f -name \*.beam \
-		| sed "s/ebin\//'/;s/\.beam/',/" | sed '$$s/.$$//'))
-	$(gen_verbose) $(call erlang,$(call triq_check.erl,all,undefined))
-endif
-endif
-
-# Copyright (c) 2015, Euen Lopez <euen@inakanetworks.com>
-# This file is part of erlang.mk and subject to the terms of the ISC License.
-
-.PHONY: xref distclean-xref
-
-# Configuration.
-
-ifeq ($(XREF_CONFIG),)
-	XREF_ARGS :=
-else
-	XREF_ARGS := -c $(XREF_CONFIG)
-endif
-
-XREFR ?= $(CURDIR)/xrefr
-export XREFR
-
-XREFR_URL ?= https://github.com/inaka/xref_runner/releases/download/0.2.0/xrefr
-
-# Core targets.
-
-help::
-	@printf "%s\n" "" \
-		"Xref targets:" \
-		"  xref        Run Xrefr using $XREF_CONFIG as config file if defined"
-
-distclean:: distclean-xref
-
-# Plugin-specific targets.
-
-$(XREFR):
-	@$(call core_http_get,$(XREFR),$(XREFR_URL))
-	@chmod +x $(XREFR)
-
-xref: deps app $(XREFR)
-	$(gen_verbose) $(XREFR) $(XREFR_ARGS)
-
-distclean-xref:
-	$(gen_verbose) rm -rf $(XREFR)
-
-# Copyright 2015, Viktor Söderqvist <viktor@zuiderkwast.se>
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 # This file is part of erlang.mk and subject to the terms of the ISC License.
 
 
-COVER_REPORT_DIR = cover
+COVER_REPORT_DIR ?= cover
-
+COVER_DATA_DIR ?= $(CURDIR)
-# utility variables for representing special symbols
-empty :=
-space := $(empty) $(empty)
-comma := ,
-
-# Hook in coverage to eunit
-
-ifdef COVER
-ifdef EUNIT_RUN
-EUNIT_RUN_BEFORE += -eval \
-	'case cover:compile_beam_directory("ebin") of \
-		{error, _} -> halt(1); \
-		_ -> ok \
-	end.'
-EUNIT_RUN_AFTER += -eval 'cover:export("eunit.coverdata").'
-endif
-endif
 
 
 # Hook in coverage to ct
 # Hook in coverage to ct
 
 
 ifdef COVER
 ifdef COVER
 ifdef CT_RUN
 ifdef CT_RUN
-
+ifneq ($(wildcard $(TEST_DIR)),)
-# All modules in 'ebin'
-COVER_MODS = $(notdir $(basename $(shell echo ebin/*.beam)))
-
 test-build:: $(TEST_DIR)/ct.cover.spec
 test-build:: $(TEST_DIR)/ct.cover.spec
 
 
-$(TEST_DIR)/ct.cover.spec:
+$(TEST_DIR)/ct.cover.spec: cover-data-dir
-	@echo Cover mods: $(COVER_MODS)
 	$(gen_verbose) printf "%s\n" \
 	$(gen_verbose) printf "%s\n" \
-		'{incl_mods,[$(subst $(space),$(comma),$(COVER_MODS))]}.' \
+		"{incl_app, '$(PROJECT)', details}." \
-		'{export,"$(CURDIR)/ct.coverdata"}.' > $@
+		'{export,"$(abspath $(COVER_DATA_DIR))/ct.coverdata"}.' > $@
 
 
 CT_RUN += -cover $(TEST_DIR)/ct.cover.spec
 CT_RUN += -cover $(TEST_DIR)/ct.cover.spec
 endif
 endif
 endif
 endif
+endif
 
 
 # Core targets
 # Core targets
 
 
 ifdef COVER
 ifdef COVER
 ifneq ($(COVER_REPORT_DIR),)
 ifneq ($(COVER_REPORT_DIR),)
 tests::
 tests::
-	@$(MAKE) --no-print-directory cover-report
+	$(verbose) $(MAKE) --no-print-directory cover-report
 endif
 endif
+
+cover-data-dir: | $(COVER_DATA_DIR)
+
+$(COVER_DATA_DIR):
+	$(verbose) mkdir -p $(COVER_DATA_DIR)
+else
+cover-data-dir:
 endif
 endif
 
 
 clean:: coverdata-clean
 clean:: coverdata-clean
@@ -2104,11 +847,11 @@ distclean:: cover-report-clean
 endif
 endif
 
 
 help::
 help::
-	@printf "%s\n" "" \
+	$(verbose) printf "%s\n" "" \
 		"Cover targets:" \
 		"Cover targets:" \
 		"  cover-report  Generate a HTML coverage report from previously collected" \
 		"  cover-report  Generate a HTML coverage report from previously collected" \
 		"                cover data." \
 		"                cover data." \
-		"  all.coverdata Merge {eunit,ct}.coverdata into one coverdata file." \
+		"  all.coverdata Merge all coverdata files into all.coverdata." \
 		"" \
 		"" \
 		"If COVER=1 is set, coverage data is generated by the targets eunit and ct. The" \
 		"If COVER=1 is set, coverage data is generated by the targets eunit and ct. The" \
 		"target tests additionally generates a HTML coverage report from the combined" \
 		"target tests additionally generates a HTML coverage report from the combined" \
@@ -2117,17 +860,20 @@ help::
 
 
 # Plugin specific targets
 # Plugin specific targets
 
 
-COVERDATA = $(filter-out all.coverdata,$(wildcard *.coverdata))
+COVERDATA = $(filter-out $(COVER_DATA_DIR)/all.coverdata,$(wildcard $(COVER_DATA_DIR)/*.coverdata))
 
 
 .PHONY: coverdata-clean
 .PHONY: coverdata-clean
 coverdata-clean:
 coverdata-clean:
-	$(gen_verbose) rm -f *.coverdata ct.cover.spec
+	$(gen_verbose) rm -f $(COVER_DATA_DIR)/*.coverdata $(TEST_DIR)/ct.cover.spec
 
 
 # Merge all coverdata files into one.
 # Merge all coverdata files into one.
-all.coverdata: $(COVERDATA)
+define cover_export.erl
-	$(gen_verbose) $(ERL) -eval ' \
+	$(foreach f,$(COVERDATA),cover:import("$(f)") == ok orelse halt(1),)
-		$(foreach f,$(COVERDATA),cover:import("$(f)") == ok orelse halt(1),) \
+	cover:export("$(COVER_DATA_DIR)/$@"), halt(0).
-		cover:export("$@"), halt(0).'
+endef
+
+all.coverdata: $(COVERDATA) cover-data-dir
+	$(gen_verbose) $(call erlang,$(cover_export.erl))
 
 
 # These are only defined if COVER_REPORT_DIR is non-empty. Set COVER_REPORT_DIR to
 # These are only defined if COVER_REPORT_DIR is non-empty. Set COVER_REPORT_DIR to
 # empty if you want the coverdata files but not the HTML report.
 # empty if you want the coverdata files but not the HTML report.
@@ -2137,6 +883,7 @@ ifneq ($(COVER_REPORT_DIR),)
 
 
 cover-report-clean:
 cover-report-clean:
 	$(gen_verbose) rm -rf $(COVER_REPORT_DIR)
 	$(gen_verbose) rm -rf $(COVER_REPORT_DIR)
+	$(if $(shell ls -A $(COVER_DATA_DIR)/),,$(verbose) rmdir $(COVER_DATA_DIR))
 
 
 ifeq ($(COVERDATA),)
 ifeq ($(COVERDATA),)
 cover-report:
 cover-report:
@@ -2145,7 +892,7 @@ else
 # Modules which include eunit.hrl always contain one line without coverage
 # Modules which include eunit.hrl always contain one line without coverage
 # because eunit defines test/0 which is never called. We compensate for this.
 # because eunit defines test/0 which is never called. We compensate for this.
 EUNIT_HRL_MODS = $(subst $(space),$(comma),$(shell \
 EUNIT_HRL_MODS = $(subst $(space),$(comma),$(shell \
-	grep -e '^\s*-include.*include/eunit\.hrl"' src/*.erl \
+	grep -H -e '^\s*-include.*include/eunit\.hrl"' src/*.erl \
 	| sed "s/^src\/\(.*\)\.erl:.*/'\1'/" | uniq))
 	| sed "s/^src\/\(.*\)\.erl:.*/'\1'/" | uniq))
 
 
 define cover_report.erl
 define cover_report.erl
@@ -2159,7 +906,8 @@ define cover_report.erl
 		true -> N - 1; false -> N end}} || {M, {Y, N}} <- Report],
 		true -> N - 1; false -> N end}} || {M, {Y, N}} <- Report],
 	TotalY = lists:sum([Y || {_, {Y, _}} <- Report1]),
 	TotalY = lists:sum([Y || {_, {Y, _}} <- Report1]),
 	TotalN = lists:sum([N || {_, {_, N}} <- Report1]),
 	TotalN = lists:sum([N || {_, {_, N}} <- Report1]),
-	TotalPerc = round(100 * TotalY / (TotalY + TotalN)),
+	Perc = fun(Y, N) -> case Y + N of 0 -> 100; S -> round(100 * Y / S) end end,
+	TotalPerc = Perc(TotalY, TotalN),
 	{ok, F} = file:open("$(COVER_REPORT_DIR)/index.html", [write]),
 	{ok, F} = file:open("$(COVER_REPORT_DIR)/index.html", [write]),
 	io:format(F, "<!DOCTYPE html><html>~n"
 	io:format(F, "<!DOCTYPE html><html>~n"
 		"<head><meta charset=\"UTF-8\">~n"
 		"<head><meta charset=\"UTF-8\">~n"
@@ -2169,7 +917,7 @@ define cover_report.erl
 	io:format(F, "<table><tr><th>Module</th><th>Coverage</th></tr>~n", []),
 	io:format(F, "<table><tr><th>Module</th><th>Coverage</th></tr>~n", []),
 	[io:format(F, "<tr><td><a href=\"~p.COVER.html\">~p</a></td>"
 	[io:format(F, "<tr><td><a href=\"~p.COVER.html\">~p</a></td>"
 		"<td>~p%</td></tr>~n",
 		"<td>~p%</td></tr>~n",
-		[M, M, round(100 * Y / (Y + N))]) || {M, {Y, N}} <- Report1],
+		[M, M, Perc(Y, N)]) || {M, {Y, N}} <- Report1],
 	How = "$(subst $(space),$(comma)$(space),$(basename $(COVERDATA)))",
 	How = "$(subst $(space),$(comma)$(space),$(basename $(COVERDATA)))",
 	Date = "$(shell date -u "+%Y-%m-%dT%H:%M:%SZ")",
 	Date = "$(shell date -u "+%Y-%m-%dT%H:%M:%SZ")",
 	io:format(F, "</table>~n"
 	io:format(F, "</table>~n"
@@ -2179,7 +927,7 @@ define cover_report.erl
 endef
 endef
 
 
 cover-report:
 cover-report:
-	$(gen_verbose) mkdir -p $(COVER_REPORT_DIR)
+	$(verbose) mkdir -p $(COVER_REPORT_DIR)
 	$(gen_verbose) $(call erlang,$(cover_report.erl))
 	$(gen_verbose) $(call erlang,$(cover_report.erl))
 
 
 endif
 endif